;   
(vl-load-com)

(defun c:average_height( / i j summ_h h nabor adr)
  (princ "\n      :")
  (setq nabor (ssget '((0 . "POINT"))))
  (if (not nabor)
    (princ "\n  .")
    (progn
      (setq i 0)
      (setq j 0);  
      (setq summ_h 0)
      (while (setq adr (ssname nabor i))
        (setq h (caddr (cdr (assoc 10 (entget adr)))))
        (if (= h 0)
          (setq j (1+ j))
          (setq summ_h (+ h summ_h))
         );if
        (setq i (1+ i))
       );while
      (princ "\n  : ")
      (princ (sslength nabor))
      (princ "\n    : ")
      (princ j)
      (princ "\n  : ")
      (princ (/ summ_h (sslength nabor)))
      (princ "\n     : ")
      (princ (/ summ_h (- (sslength nabor) j)))
     );progn
   );if
  (princ)
 );defun

(defun memvar(n / varlist)
  (setq varlist 
    '( "aflags"      "angbase"     "angdir"      "aperture"
       "attdia"      "attmode"     "attreq"      "auditctl"
       "aunits"      "auprec"      "blipmode"    "cecolor"
       "celtscale"   "celtype"     "circlerad"   "clayer"
       "cmddia"      "cmdecho"     "cmljust"     "cmlscale"
       "cmlstyle"    "coords"      "cvport"      "dragmode"
       "elevation"   "expert"      "explmode"    "filedia"
       "filletrad"   "fillmode"    "fontalt"     "fontmap"
       "gridmode"    "gridunit"
       "ltscale"     "lunits"      "luprec"      "menuctl"
       "menuecho"    "offsetdist"  "orthomode"   "osmode"
       "pdmode"      "pdsize"      "plinewid"    "qtextmode"
       "snapang"     "snapbase"    "snapmode"
       "texteval"    "textfill"    "textsize"    "textstyle"
       "edgemode"    "projmode"
      )
   );setq
  (if (= n 0)
    (setq memvarlist (mapcar 'getvar varlist))
    (if (and (= n 1) memvarlist)
      (mapcar '(lambda (par1 par2) (setvar par1 par2)) varlist memvarlist)
     );if
   );if
 );defun

(defun memvar(n / varlist)
  (setq varlist 
    '( "aflags"      "angbase"     "angdir"      "aperture"
       "attdia"      "attmode"     "attreq"      "auditctl"
       "aunits"      "auprec"      "blipmode"    "cecolor"
       "celtscale"   "celtype"     "circlerad"   "clayer"
       "cmddia"      "cmdecho"     "cmljust"     "cmlscale"
       "cmlstyle"    "coords"      "cvport"      "dragmode"
       "elevation"   "expert"      "explmode"    "filedia"
       "filletrad"   "fillmode"    "fontalt"     "fontmap"
       "gridmode"    "gridunit"
       "ltscale"     "lunits"      "luprec"      "menuctl"
       "menuecho"    "offsetdist"  "orthomode"   "osmode"
       "pdmode"      "pdsize"      "plinewid"    "qtextmode"
       "snapang"     "snapbase"    "snapmode"
       "texteval"    "textfill"    "textsize"    "textstyle"
       "edgemode"    "projmode"
      )
   );setq
  (if (= n 0)
    (setq memvarlist (mapcar 'getvar varlist))
    (if (and (= n 1) memvarlist)
      (mapcar '(lambda (par1 par2) (setvar par1 par2)) varlist memvarlist)
     );if
   );if
 );defun

(defun creat_text(listpar / txt p0 h col lay angl xscale p1 halign valign tstyle spisok)
  (setq txt (car listpar)); 
  (setq listpar (cdr listpar))
  (setq p0 (car listpar));  
  (setq listpar (cdr listpar))
  (setq h (car listpar)); 
  (setq listpar (cdr listpar))
  (setq col (car listpar)); 
  (setq listpar (cdr listpar))
  (setq lay (car listpar)); 
  (setq listpar (cdr listpar))
  (setq angl (car listpar)); 
  (setq listpar (cdr listpar))
  (setq xscale (car listpar)); 
  (setq listpar (cdr listpar))
  (setq p1 (car listpar));  
  (setq listpar (cdr listpar))
  (setq halign (car listpar)); 
  (setq listpar (cdr listpar))
  (setq valign (car listpar)); 
  (setq listpar (cdr listpar))
  (setq tstyle (car listpar)); 
  (setq listpar (cdr listpar))
  (setq spisok
    (list
      (cons 0 "TEXT")
      (cons 1 txt)
      '(71 . 0)
      '(39 . 0)
     );list
   );setq
  (if p0 (setq spisok (reverse (cons (cons 10 p0) (reverse spisok)))))
  (if h (setq spisok (reverse (cons (cons 40 h) (reverse spisok)))))
  (if col (setq spisok (reverse (cons (cons 62 col) (reverse spisok)))))
  (if lay (setq spisok (reverse (cons (cons 8 lay) (reverse spisok)))))
  (if angl (setq spisok (reverse (cons (cons 50 angl) (reverse spisok)))))
  (if xscale (setq spisok (reverse (cons (cons 41 xscale) (reverse spisok)))))
  (if p1 (setq spisok (reverse (cons (cons 11 p1) (reverse spisok)))))
  (if halign (setq spisok (reverse (cons (cons 72 halign) (reverse spisok)))))
  (if valign (setq spisok (reverse (cons (cons 73 valign) (reverse spisok)))))
  (if tstyle (setq spisok (reverse (cons (cons 7 tstyle) (reverse spisok)))))
  (entmake spisok)
 );defun

;txt -  ( 1)
;p0 -   ( 10)
;h -   ( 40)
;col -  ( 62)
;lay -  ( 8)
;angl -   ( 50)
;xscale -   ( 41)
;p1 -    ( 11)
;halign -   ( 72)
  ;0 - left
  ;1 - center
  ;2 - right
  ;3 - aligned
  ;4 - middle
  ;5 - fit
;valign -   ( 73)
  ;0 - baseline
  ;1 - bottom
  ;2 - middle
  ;3 - top
;tstyle -   ( 7)
