;Tip1750:  COPYR.LSP        Copy and rotate        (C)2001, Ricardo Lopez

 ;*****************************************************
 ; COPYR.LSP    (Copy and rotate objects)
 ;*****************************************************
(defun C:COPYR (/ N POINT2 LAST1 LAST2 ROTATE_POINT)
  (setvar "osmode" 0)
  (setvar "orthomode" 0)
  (setq EN (ssget))
  (command "_undo" "_begin")
  (if EN
    (progn
      (setq N 0)
      (while (< N (sslength EN))
	(redraw (ssname EN N) 3)
	(setq N (+ N 1))
      )
      (initget "M")
      (setq POINT2 (getpoint "\nBase point or displacement/Multiple:"))
      (if (= POINT2 "M")
	(progn (setq POINT2 (getpoint "\nBase point:"))
	       (while POINT2
		 (command "_.move" EN "" POINT2)
		 (setq LAST1 (getvar "lastpoint"))
		 (command PAUSE)
		 (setq LAST2 (getvar "lastpoint"))
		 (setq ROTATE_POINT (getvar "lastpoint"))
		 (command "_.copy" EN "" ROTATE_POINT POINT2)
		 (command "_.rotate")
		 (command "_p" "" ROTATE_POINT PAUSE)
		 (setq POINT2 ROTATE_POINT)
	       )
	)
	(progn (if POINT2
		 (progn	(command "_.move" EN "" POINT2 PAUSE)
			(setq BASE (getvar "lastpoint"))
			(command "_.copy" EN "" BASE POINT2)
			(command "_.rotate" "_p" "" BASE PAUSE)
		 )
	       )
	)
      )
      (setq N 0)
      (while (< N (sslength EN))
	(redraw (ssname EN N) 4)
	(setq N (+ N 1))
      )
    )
  )
  (command "_undo" "_begin")
  (princ)
)