;;------------------------DCL_TO_LISP--------------------------------;;
;;    DCL   .                      ;;
;;     DCL-    .  ;;
;;  Author: roaa@mail.ru, Copyright  07.2013                        ;;
;;-------------------------------------------------------------------;;
(defun C:DCL_TO_LISP ()
  (setq dcl_lst  (_sensor:dat->lst nil "dcl")
        dcl_name (vl-filename-base (car dcl_lst)) 
        dcl_str 
                 (append
                   (list
                         (strcat "(defun _" (strcat dcl_name "_dcl") " ( / tmp_folder tmp_file )")
                                 "  (setq tmp_folder (strcat (vl-filename-directory (vl-filename-mktemp)) \"\\\\\")"
                                 "        tmp_file   (strcat "
                                 "                     tmp_folder "
                         (strcat "                     " (vl-prin1-to-string (strcat dcl_name ".dcl")))
                                 "                   )"
                                 "  )"
                                 "  (if"
                                 "    (findfile tmp_file)"
                                 "    (vl-file-delete tmp_file)"
                                 "  )"
                                 "  (setq tmp_lst" 
                                 "    (list " 
                   )
                   (mapcar 'vl-prin1-to-string (cadr dcl_lst))                       
                   (list
                                 "    )"
                                 "  )"
                                 "  (_sensor:lst->dat tmp_file tmp_lst T)"
                                 ")"
                                 ""
                                 ""
                                 ""
                                 ";;----------------      ----------------;;"
                                 ";;                                                            ;;"
                                 ";;         .      ;;"
                                 ";;------------------------------------------------------------;;"
                                 ";;  Author: roaa@mail.ru, Copyright  03.2013                 ;;"
                                 ";;------------------------------------------------------------;;"
                                 ";;  :                                                ;;"
                                 ";;  filename -  , nil                 ;;"
                                 ";;  data -                                ;;"
                                 ";;  extension -  ,    filename        ;;"
                                 ";;------------------------------------------------------------;;"
                                 ";;  ::  T  ,  nil                    ;;"
                                 ";;  test:                                                     ;;"
                                 ";; (_sensor:lst->dat nil                                      ;;"
                                 ";;   (cadr (_SENSOR:DAT->LST nil \"txt\")) \"dat\")           ;;"
                                 ";;------------------------------------------------------------;;"
                                 ""
                                 "(defun _sensor:lst->dat ( filename data extension / file )"
                                 "  (if (not filename) "
                                 "    (setq filename (getfiled \"Create Output File\" \"\" extension 1))"
                                 "  )"
                                 "  (if (setq file (open filename \"w\"))"
                                 "    (progn"
                                 "      (cond (  (= (type data) 'STR)"
                                 "               (write-line data file)"
                                 "            )"
                                 "            (  (= (type data) 'LIST)"
                                 "               (foreach line data "
                                 "                 (write-line line file)"
                                 "               )"
                                 "            )"
                                 "      )"
                                 "      (close file)"
                                 "      filename"
                                 "    )"
                                 "    nil"
                                 "  )"
                                 ")"
                   )
                 )
  )
  (_sensor:lst->dat (strcat (vl-filename-directory (car dcl_lst)) "\\" dcl_name "_dcl.lsp") dcl_str T)
)



;;-----------------     -------------------;;
;;                                                            ;;
;;    ,  .             ;;
;;------------------------------------------------------------;;
;;  Author: roaa@mail.ru, Copyright  03.2013                 ;;
;;------------------------------------------------------------;;
;;  :                                                ;;
;;  filename -  , nil                 ;;
;;  extension -  ,    filename        ;;
;;------------------------------------------------------------;;
;;  :                                  ;;
;;------------------------------------------------------------;;

(defun _sensor:dat->lst ( filename extension / file)
  (setq scroll nil)
  (if 
    (not filename)
    (setq filename (getfiled "   " "C:\\" extension 0))          
  )
  (if (not (vl-file-size filename))
    (progn
      (princ "\n  !")
      (setq scroll "")
    )
    (progn
      (setq file (open filename "r"))
      (while 
        (setq line (read-line file))
        (setq scroll (cons line scroll))
      )
      (close file)
    )
  ) 
  (princ "\n")
  (list filename (reverse scroll))
)



;;----------------      ----------------;;
;;                                                            ;;
;;         .      ;;
;;------------------------------------------------------------;;
;;  Author: roaa@mail.ru, Copyright  03.2013                 ;;
;;------------------------------------------------------------;;
;;  :                                                ;;
;;  filename -  , nil                 ;;
;;  data -                                ;;
;;  extension -  ,    filename        ;;
;;------------------------------------------------------------;;
;;  ::  T  ,  nil                    ;;
;;  test:                                                     ;;
;; (_sensor:lst->dat nil                                      ;;
;;   (cadr (_SENSOR:DAT->LST nil "txt")) "dat")               ;;                               
;;------------------------------------------------------------;;

(defun _sensor:lst->dat ( filename data extension / file )
  (if (not filename) 
      (setq filename (getfiled "Create Output File" "" extension 1))
  )
  (if (setq file (open filename "w"))
      (progn
        (cond ((= (type data) 'STR)
               (write-line data file)
              )
              ((= (type data) 'LIST)
               (foreach line data 
                 (write-line line file)
               )
              )
         )
         (close file)
         filename
      )
      nil
  )
)


(defun C:ReDCL ()
  (setq file
             (getfiled " " 
               (vla-get-Path 
                 (vla-get-activedocument 
                   (vlax-get-acad-object)
                 )
               ) 
               "lsp;fas;vlx"
               0
             )
        fisb (vl-filename-base file)
  )
  (load file)  
  (vl-file-copy 
    (eval (read (strcat "(_" (vl-filename-base file) ")")))
    (strcat (vl-filename-directory file) "\\" 
      (substr fisb 1 (- (strlen fisb) 4)) 
      ".dcl"
    )
  )  
)