(defun mip-reg-get-path ()"HKEY_LOCAL_MACHINE\\Software\\MIP")
(defun mip-reg-write (key value ) ;;;     
(vl-registry-write (mip-reg-get-path)
(VL-PRINC-TO-STRING key)(VL-PRINC-TO-STRING value)))
(defun mip-reg-read ( key )(vl-registry-read (mip-reg-get-path)
(VL-PRINC-TO-STRING key)))
(defun mip-conv-to-str (dat)
  (cond ((= (type dat) 'INT)(setq dat (itoa dat)))
         ((= (type dat) 'REAL)(setq dat (rtos dat 2 12)))
        ((null dat)(setq dat ""))
        (t (setq dat (vl-princ-to-string dat)))))
  (defun mydclseldict (zagl info-list / fl ret dcl_id str)
(defun prepare ( / fn1 fl1 lst1 str1)
(if (vl-file-systime (setq fn1 (strcat (mip-conv-to-str(mip-reg-read "LASTDIR")) "\\"
     (mip-conv-to-str(mip-reg-read "LASTFILE")))))
    (progn
     (set_tile "tp2" (vl-filename-base fn1)) 
     (setq fl1 (open fn1 "r"))
     (while (setq str1 (read-line fl1))
      (if (/= (vl-string-trim " \t\n" str1) "")
      (setq lst1 (cons str1 lst1))))
      (close fl1)
      (setq info-list (acad_strlsort lst1))
      (start_list "info")
      (mapcar 'add_list info-list)
      (end_list)
      (set_tile "info" "0")
 
      )
    )  
  )
(defun pickdict ( / fn1 fl1 ret1 )
    (if (setq FN1 (getfiled "  " (mip-conv-to-str(mip-reg-read "LASTDIR")) "txt" 16))
      (progn
 (mip-reg-write "LASTDIR" (vl-filename-directory fn1))
 (mip-reg-write "LASTFILE" (strcat (vl-filename-base fn1)(vl-filename-extension fn1)))
 (if (vl-file-systime fn1)
   (progn
     (setq fl1 (open fn1 "r"))
     (while (setq str (read-line fl1))
       (if (/= (vl-string-trim " \t\n" str) "")
       (setq ret1 (cons str ret1))))
     (close fl1)
     (setq info-list (acad_strlsort ret1))
     (start_list "info")
            (mapcar 'add_list info-list)
            (end_list)
            (set_tile "info" "0")
     (set_tile "tp2" (vl-filename-base fn1))
     )
   )
 )
      )
    )
  (defun act-info ()
    (setq ret (nth (atoi $value) info-list))
    (mode_tile "accept" 2)
    )
    (vl-load-com)
    (if (null zagl)(setq zagl "")) ;_ end of if
    (setq fl (vl-filename-mktemp "mip" nil ".dcl"))
    (setq ret (open fl "w"))
    (mapcar '(lambda (x) (write-line x ret))
        (list    
"mydclseldict : dialog {"
(strcat "label=\"" zagl "\";")
 ": row{label=\" \";"
 ":column{"
 ": concatenation {key=\"c1\";"
 ": text_part{label=\": \"; key=\"tp1\";}"
 ": text_part{label=\"  \"; key=\"tp2\";width=30;}"
 "}}"
 ":column{"
 ": button {fixed_width=true;width=3;key=\"pick\";label= \"&<\";alignment=right;}"
 "}}"
":row{label=\"\";"
 " :list_box {"
 "alignment=top ;"
 "width=51 ;"
; (if (> (length info-list) 26)
    "height= 26 ;"
 ;      (strcat "height= " (itoa (+ 3 (length info-list))) ";")) ;_ end of if
  "is_tab_stop = false ;"
  "key = \"info\";}}"
  "ok_cancel;}"
))
(setq ret (close ret))
(if (setq dcl_id (load_dialog fl))
        (if (new_dialog "mydclseldict" dcl_id)
            (progn
               (if (null info-list)(prepare))
                (start_list "info")
                (mapcar 'add_list info-list)
                (end_list)
                (set_tile "info" "0")
                (setq ret (car info-list))
                (action_tile "pick" "(pickdict)")
;                (action_tile "info" "(setq ret (nth (atoi $value) info-list))")
                (action_tile "info" "(act-info)")
;                (action_tile "info" "(progn(setq ret (nth (atoi $value) info-list))(mode_tile \"accept\" 2))")
 
                (action_tile "cancel" "(progn(setq ret nil)(done_dialog 0))")
                (action_tile "accept" "(done_dialog 1)")
                (start_dialog)
            ) ;_ end of progn
        ) ;_ end of if
    ) ;_ end of if
    (unload_dialog dcl_id)
    (vl-file-delete fl)
    ret
)
  ;;; Text To Text copy
;;; Original posted {Smirnoff}
;;; http://www.caduser.ru/cgi-bin/f1/board.cgi?t=21807yD
;;; Modifyed V. Azarko (VVA) 
;;; http://www.caduser.ru/cgi-bin/f1/board.cgi?t=21807yD
  (defun TTC_Paste(pasteStr / nslLst vlaObj hitPt
                   hitRes Row Column lst ss)
    (setq errFlag nil)
  (setvar "ERRNO" 0)
    (while (progn
      (setq Lst(nentsel "\nPaste text or first point of corner <Enter-exit> >>"))
      (cond ((= Lst "Switch")
      (TTC_ls)
      (setvar "ERRNO" 0)
      (initget "Switch")
      T
      )
;;;     ((and (null Lst)
;;;    (= (getvar "errno") 7)
;;;    )
;;;      (princ "* Missing * ")
;;;      (setvar "ERRNO" 0)
;;;      (initget "Switch")
;;;      T
;;;      )
     (t nil)
     )
      )
      );_while
 
  (if (and (null Lst)
    (= (getvar "errno") 7)
    (setq hitPt (getcorner  (setq vlaObj (cadr(GRREAD nil 1))) "\nOther point: "))
    (setq ss (ssget "_C" vlaObj hitPt '((0 . "*TEXT"))))
    )
    (progn
    (setq Lst (mapcar '(lambda(x)(cons x '((0 0 0))))
   (vl-remove-if 'listp (mapcar 'cadr (ssnamex ss)))
     )
   )
    )
    (setq Lst (list Lst))
    )
(foreach nsllst Lst
    (if nsllst ;(setq nslLst(nentsel "\nPaste text >"))
      (progn
  (cond
    (
     (and
       (= 4(length nslLst))
       (= "DIMENSION"(cdr(assoc 0(entget(car(last nslLst))))))
       ); end and
     (setq vlaObj
      (vlax-ename->vla-object
        (cdr(assoc -1(entget(car(last nslLst)))))))
     (if
       (vl-catch-all-error-p
         (vl-catch-all-apply
     'vla-put-TextOverride(list vlaObj pasteStr)))
         (progn
         (princ "\n Can't paste. Object may be on locked layer. ")
         (setq errFlag T)
         ); end progn
       ); end if
     ); end condition #1
    (
     (and
       (= 4(length nslLst))
       (= "ACAD_TABLE"(cdr(assoc 0(entget(car(last nslLst))))))
       ); end and
     (setq vlaObj
      (vlax-ename->vla-object
        (cdr(assoc -1(entget(car(last nslLst))))))
     hitPt(vlax-3D-Point(trans(cadr nslLst)1 0))
     hitRes(vla-HitTest vlaObj hitPt
        (vlax-3D-Point '(0.0 0.0 1.0)) 'Row 'Column)
           ); end setq
     (if(= :vlax-true hitRes)
     (progn
         (if
     (vl-catch-all-error-p
       (vl-catch-all-apply
         'vla-SetText(list vlaObj Row Column pasteStr)))
     (progn
       (princ "\n Can't paste. Object may be on locked layer. ")
       (setq errFlag T)
       ); end progn
     ); end if
         ); end progn
       ); end if
     ); end condition # 2
    (
     (and
       (= 4(length nslLst))
       (= "INSERT"(cdr(assoc 0(entget(car(last nslLst))))))
       ); end and
     (princ "\nCan't paste to block's DText or MText. Select Attribute ")
     (setq errFlag T)
     ); end condition #3
    (
     (and
       (= 2(length nslLst))
         (member(cdr(assoc 0(entget(car nslLst))))
           '("TEXT" "MTEXT" "ATTRIB" "ATTDEF" "MULTILEADER"))
       ); end and
     (setq vlaObj
      (vlax-ename->vla-object(car nslLst)))
        (if
     (vl-catch-all-error-p
       (vl-catch-all-apply
         'vla-put-TextString(list vlaObj pasteStr)))
    (progn
       (princ "\nError. Can't pase text. ")
      (setq errFlag T)
      ); end progn
     ); end if
     ); end condition #4
    (T
     (princ "\nCan't paste. Invalid object. ")
     (setq errFlag T)
     ); end condition #5
    ); end cond
             T
      ); end progn
            nil
           ); end if
  )
    ); end of TTC_Paste
  (defun C:NBOOK ( )
    (vl-load-com)
    (and
      (setq str (mydclseldict " " nil))
      (TTC_Paste str)
      )
    )
(defun C:NBOOK1 ( / txt str pt tblobj row col tblset lst )
    (vl-load-com)
    (if
    (and
      (setq str (mydclseldict " " nil))
      (setq txt (entmakex
      (list
        (cons 0 "TEXT")
        (cons 100 "AcDbEntity")
        (cons 100 "AcDbText")
        (cons 72 0)           ;_  
        (cons 1 str)
       (cons 7 (getvar "TEXTSTYLE")) ;_ 
        ;(cons 8 layer) ;_ 
        (cons 10 '(0 0 0))
        (cons 11 '(0 0 0))
        (cons 40 (getvar "TEXTSIZE")) ;_   ( TEXTSIZE)
        (cons 41 1.0) ;_ /
        ) ;_ list
      ) ;_ entmakex
          )
 
      )
    (progn
      (princ "\n       :")
      (vl-cmdf "_.copybase" (trans '(0 0 0) 0 1) txt "" "_.erase" txt "" "_.pasteclip" "_none" pause)
        ;_  txt    pt    
       (setq txt (entlast) pt (getvar "LASTPOINT"))
      (and ;_,      
      (setq  tblobj nil tblset (ssget "_X" '((0 . "ACAD_TABLE"))))
      (setq lst (mapcar 'vlax-ename->vla-object(vl-remove-if 'listp (mapcar 'cadr (ssnamex tblset)))))
      (mapcar '(lambda (x)
           (or tblobj
               (and
                 (= :vlax-true (vla-HitTest x
                               (vlax-3d-point (trans pt 1 0))
                               (vlax-3d-point (trans (getvar "VIEWDIR") 1 0))
                               'row 'col))
                 (setq tblobj x)
                 )
               )
           )
        lst)
      tblobj row col
      (or (vla-SetText tblobj row col str) t)
      (entdel txt)
      )
      )
    )
    (princ)
    )