(defun C:PERPECC (/ *error* osm cmd adoc pt1 pt2 crv ang1 ang2 ang)

	(defun *error* (msg)
		(vl-cmdf "_redrawall")
		(vla-EndUndoMark adoc)
		(setvar "OSMODE" osm)
		(setvar "CMDECHO" cmd)
	)
	(setq osm (getvar "OSMODE"))
	(setq cmd (getvar "CMDECHO"))
	(vl-load-com)
	(setq adoc (vla-get-activedocument (vlax-get-acad-object)))
	(vla-StartUndoMark adoc)
	(setvar "CMDECHO" 0)
	(setvar "OSMODE" 547)
	(setq pt1 (getpoint "\n    <> : "))
	(setq crv (vlax-ename->vla-object (ssname (ssget pt1 '((0 . "*LINE"))) 0)))
	(setq pt2 (vlax-curve-getPointAtParam crv (+ (vlax-curve-getParamAtPoint crv pt1) 0.0001)))
	(if (null pt2)(setq pt2 (vlax-curve-getPointAtParam crv (- (vlax-curve-getParamAtPoint crv pt1) 0.0001))))
	(setq ang1 (* 0.5 pi))
	(setq ang2 (angle pt1 pt2))
	(setq ang (+ ang1 ang2))
	(setq ang (angtos ang 0 15))
	(vl-cmdf "_.LINE" "_none" pt1 (strcat "<" ang))(princ "      : ")(vl-cmdf pause "")
	(setvar "OSMODE" osm)
	(setvar "CMDECHO" cmd)
	(vla-EndUndoMark adoc)
	(vl-cmdf "_redrawall")
	(princ)
)