;;------> PROKAT 3D<--------------------------------------------
;; version 24-07-2007
;;   :  .
;;           , .
;;        mail: flashcon@yandex.ru
;;
;;
;; version 01-01-2007       Alan
;;   2007: Alan&kpblc
;;; :         kpblc'a
;;;;;      
;;;            	*alan-steel-saved-profile-type*
;;;		*alan-steel-saved-profile-number*
;;;  		*alan-layer-saved*


;;;      

(vl-load-com)
(defun c:prkt3d	(/	cmd    blpm      osmd   clay   cltp
		 ccol	dvtp   dvt    shr    shp    shg	   ugr
		 ugn	trprf  ugrg   ugng   dvcl   lib	   dvd
		 dvdp	svrd   svpd   ugrd   svgkd  uggrkd uggnkd
		 dvdpas	trkvd  trpud  svgd   ugrd   uggrd  uggnd
		 ugnd	name1  orx    aby    spr    dlndt  dlina
		 ves	gost   stepen x	     a	    aa	   aaa
		 b	bb     bbb    dlnug  blpm *error*
;;;      19425-74
		 dvd1	dvd2
		 sp_lay	nm_lr tl_lr fr_lr  mark_p
		)
;;; -    26.08.2007 VVA
(defun *error* (msg)(princ msg)(setvar "osmode" osmd)
  (vla-EndUndoMark (vla-get-activedocument (vlax-get-acad-object))))
  (vl-load-com) ;;;  02.08.2007 VVA
  (vla-StartUndoMark (vla-get-activedocument (vlax-get-acad-object)))
		
  (setq	cmd  (getvar "cmdecho")
	blpm (getvar "blipmode")
	osmd (getvar "osmode")
	clay (getvar "clayer")
	cltp (getvar "celtype")
	ccol (getvar "cecolor")
  ) ;_  setq
  (setvar "cmdecho" 0)
  (setvar "blipmode" 0)
  (setvar "osmode" 0)

;;;;;;------------------------------ 1.08.07  ----------------------------------
;;;   
  (setq	dvcl   (findfile "d_vtr3d.dcl")
	lib    (findfile "procat.slb")
	dvdp   (findfile "dvtp.dat")
	dvdpas (findfile "dvtpas.dat")
	dvd    (findfile "dvtr.dat")
	dvd1   (findfile "dvtr2.dat")
	dvd2   (findfile "dvtp2.dat")
	svrd   (findfile "svlr.dat")
	svpd   (findfile "svlrp.dat")
	svgd   (findfile "svlrg.dat")
	svgkd  (findfile "svlrgK.dat")
	ugrd   (findfile "ugrp.dat")
	uggrd  (findfile "ugrg.dat")
	uggrkd (findfile "ugrgK.dat")
	uggnd  (findfile "ugng.dat")
	uggnkd (findfile "ugngK.dat")
	ugnd   (findfile "ugnp.dat")
	trkvd  (findfile "trkv.dat")
	trpud  (findfile "trpu.dat")
  ) ;_  setq
;;;    _kpblc-error-catch    
;;;    
  (setq	dvtp  "dvt_p3d.lsp"
	dvt   "dvt_r3d.lsp"
	shr   "shv_r3d.lsp"
	shp   "shv_rp3d.lsp"
	shg   "shv_rg3d.lsp"
	ugr   "ug_rp3d.lsp"
	ugn   "ug_np3d.lsp"
	ugrg  "ug_rg3d.lsp"
	ugng  "ug_ng3d.lsp"
	trprf "tr_prf3d.lsp"
  ) ;_ end of setq


  (foreach item	(list "_kpblc-linetype-load_.lsp" dvtp
		      dvt	    shr		  shp
		      shg	    ugr		  ugn
		      ugrg	    ugng	  trprf
		     ) ;_  list

    (_kpblc-error-catch
      (function
	(lambda	()
	  (load (findfile item))
	) ;_ end of lambda
      ) ;_ end of function
      '(lambda (x)
	 (princ
	   (strcat "\n   "
		   (vl-princ-to-string item)
		   " : "
		   x
	   ) ;_  strcat
	 ) ;_ end of princ
       ) ;_ end of lambda
    ) ;_ end of _kpblc-error-catch
  ) ;_ end of foreach

;;;;;;	       	 
  (setq sp_lay (list (cdr (assoc 2 (tblnext "LAYER" t))))) ;_  setq
  (while (setq fr_lr (tblnext "LAYER"))
    (progn
      (setq nm_lr (cdr (assoc 2 fr_lr))
	    fr_lr (cdr (assoc 70 fr_lr))
      ) ;_  setq
      (if (and nm_lr (/= nm_lr "Defpoints") (= 0 fr_lr))
	(setq sp_lay
	       (cons nm_lr sp_lay)
	) ;_  setq
      ) ;_  if
    ) ;_  progn
  ) ;_  while
  (setq	sp_lay		   (reverse sp_lay)
	*alan-layer-saved*
			   (if
			     (and *alan-layer-saved*
				  (member *alan-layer-saved* sp_lay)
			     ) ;_  and
			      *alan-layer-saved*
			      "0"
			   ) ;_  if

;;;        
	pr_fl		   (if *alan-steel-saved-profile-type*
			     *alan-steel-saved-profile-type*
			     "0"
			   ) ;_  if

	rr		   (if *alan-steel-saved-profile-number*
			     *alan-steel-saved-profile-number*
			     "0"
			   ) ;_  if


  ) ;_  setq


;;;------------------------------ 1.08.07   ------------------------------------------


  (defun show_im2 (name1)
    (setq orx (dimx_tile "show_image1")
	  aby (dimy_tile "show_image1")
    ) ;_ end of setq
    (start_image "show_image1")
    (fill_image 0 0 orx aby 444)
    (slide_image 0 0 orx aby name1)
    (end_image)
  ) ;_ end of defun


  (defun name ()
    (cond		      ;25
      ((or (eq pr_fl "2") (eq pr_fl "3"))
       (setq name1 (strcat lib "(3)"))
      )
      ((or (eq pr_fl "4") (eq pr_fl "5"))
       (setq name1 (strcat lib "(6)"))
      )
      ((eq pr_fl "6") (setq name1 (strcat lib "(7)")))
      ((or (eq pr_fl "7") (eq pr_fl "8"))
       (setq name1 (strcat lib "(8)"))
      )
      ((eq pr_fl "9") (setq name1 (strcat lib "(11)")))
      ((eq pr_fl "10") (setq name1 (strcat lib "(16)")))
      ((or (eq pr_fl "11") (eq pr_fl "12"))
       (setq name1 (strcat lib "(17)"))
      )
      ((or (eq pr_fl "13") (eq pr_fl "14"))
       (setq name1 (strcat lib "(18)"))
      )
      ((or (eq pr_fl "0") (eq pr_fl "1"))
       (setq name1 (strcat lib "(19)"))
      )
      ((eq pr_fl "15") (setq name1 (strcat lib "(20)")))
      ((eq pr_fl "16") (setq name1 (strcat lib "(22)")))
    ) ;_ end of cond
  ) ;_ end of defun

  (defun show (/ dcl_id)
    (setq dcl_id
	   (load_dialog
	     dvcl
	   ) ;_ end of load_dialog
    )			      ; DCL-
    (if	(not (new_dialog "dvtr3d" dcl_id)) ; 
      (exit)
    )			      ;(,   )


    (defun name_fil ()
      (cond
	((eq pr_fl "0")
	 (setq gost "  26020"
	       fil  dvdp
	 ) ;_  setq
	)
	((eq pr_fl "1")
	 (setq gost "   20"
	       fil  dvdpas
	 ) ;_  setq
	)
	((eq pr_fl "2")
	 (setq gost "  8239"
	       fil  dvd
	 ) ;_  setq
	)
	((eq pr_fl "3")
	 (setq gost "  19425"
	       fil  dvd1
	 ) ;_  setq
	)		      ;25
	((eq pr_fl "4")
	 (setq gost "  19425"
	       fil  dvd2
	 ) ;_  setq
	)		      ;25
	((eq pr_fl "5")
	 (setq gost "  8240"
	       fil  svrd
	 ) ;_  setq
	)
	((eq pr_fl "6")
	 (setq gost "  8240"
	       fil  svpd
	 ) ;_  setq
	)
	((eq pr_fl "7")
	 (setq gost "  8278"
	       fil  svgd
	 ) ;_  setq
	)
	((eq pr_fl "8")
	 (setq gost "  8278"
	       fil  svgkd
	 ) ;_  setq
	)
	((eq pr_fl "9")
	 (setq gost "  8509"
	       fil  ugrd
	 ) ;_  setq
	)
	((eq pr_fl "10")
	 (setq gost "  8510"
	       fil  ugnd
	 ) ;_  setq
	)
	((eq pr_fl "11")
	 (setq gost "  19771"
	       fil  uggrd
	 ) ;_  setq
	)
	((eq pr_fl "12")
	 (setq gost "  19771"
	       fil  uggrkd
	 ) ;_  setq
	)
	((eq pr_fl "13")
	 (setq gost "  19772"
	       fil  uggnd
	 ) ;_  setq
	)
	((eq pr_fl "14")
	 (setq gost "  19772"
	       fil  uggnkd
	 ) ;_  setq
	)
	((eq pr_fl "15")
	 (setq gost "  30245"
	       fil  trkvd
	 ) ;_  setq
	)
	((eq pr_fl "16")
	 (setq gost "  30245"
	       fil  trpud
	 ) ;_  setq
	)
      ) ;_ end of cond
    ) ;_ end of defun


    (defun desk_f ()
      (setq x	(open (name_fil) "r")
	    a	(read-line x)
	    aa	(read a)
	    b	(read-line x)
	    bb	(read b)
	    aaa	(nth 0 bb)
	    bbb	(nth 9 bb)
      ) ;_ end of setq
    ) ;_ end of defun
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    (setq sortam
	   '("   26020-83    "
	     "    20-93    "
	     "   8239-89     "
	     "   19425-74     "
			      ;25
	     "   19425-74     "
			      ;25
	     "   8240-97     "
	     "   8240-97    "
	     "    8278-83 . "
	     "    8278-83 . "
	     "   8509-93 "
	     "   8510-86 "
	     "    19771-93  . "
	     "    19771-93  . "
	     "    19772-93  . "
	     "    19772-93  . "
	     "       30245-03"
	     "       30245-03")
    ) ;_  setq
    (defun profil (/)
      (start_list "prfl")
      (mapcar 'add_list sortam)
      (end_list)
    ) ;_  defun
    (profil)
    ;;;------------------------------ 01.08.07  ----------------------------------
;;;      
    (start_list "s_l")
    (mapcar 'add_list sp_lay)
    (end_list)
;;;     
    (set_tile "s_l" (itoa (vl-position *alan-layer-saved* sp_lay)))

;;;------------------------------ 01.08.07   ------------------------------------------

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    (defun r_r ()
      (start_list "n")
      (mapcar 'add_list aa)
      (end_list)
    ) ;_ end of defun


    (defun chart ()
      (start_list "sprav")
      (mapcar 'add_list bbb)
      (end_list)
    ) ;_ end of defun


    (defun clos_x ()
      (close x)
      (desk_f)
    ) ;_ end of defun

    (defun whl ()
      (if (< (atof rr) (atof aaa))
	(clos_x)
      ) ;_ end of if
      (while (/= (atof rr) (atof aaa))
	(setq b	  (read-line x)
	      bb  (read b)
	      aaa (nth 0 bb)
	      bbb (nth 9 bb)
	) ;_ end of setq
      ) ;_ end of while
    ) ;_ end of defun

;;;------------------------------ 01.08.07  ----------------------------------
;;;       
    (action_tile "s_l" "(progn (setq mark_p $value))")
;;;------------------------------ 01.08.07   ------------------------------------------

    (if	(action_tile "prfl" "")
      (progn
	(setq dlnug "0")
	(mode_tile "dln_dt" 0)
	(mode_tile "dl_ug" 0)
	(if (eq pr_fl nil)
	  (setq pr_fl "0")
	) ;_  if

	(set_tile "prfl" pr_fl)
	(desk_f)
	(r_r)
	(if (eq rr nil)
	  (setq rr "0")
	) ;_  if
	(set_tile "n" rr)
	(whl)
	(chart)
	(show_im2 (name))
      ) ;_ end of progn
    ) ;_ end of if


    (defun ukas	()
      (cond
	((eq dlnug "1") (mode_tile "dln_dt" 1))
	((eq dlnug "0") (mode_tile "dln_dt" 0))
      ) ;_ end of cond
    ) ;_ end of defun


    (defun hlp ()
      (set_tile "help" ": >>>")
    ) ;_ end of defun

    (defun a_prfl (/)
      (action_tile
	"prfl"
	(strcat
	  "(progn (setq pr_fl (get_tile \"prfl\"))"
	  "(desk_f)"			"(r_r)"
	  "(setq rr \"0\")"		"(chart)"
	  "(show_im2 (name)))"		"(set_tile \"n\" \"0\")"
	  "(hlp)"
	 ) ;_  strcat
 ;_  strcat
 ;_ end of strcat
      ) ;_ end of action_tile
    ) ;_  defun

    (a_prfl)

    (defun a_n (/)
      (action_tile
	"n"
	(strcat
	  "(progn (setq rr (get_tile \"n\"))"
	  "(whl)"
	  "(chart))"
	  "(hlp)"
	) ;_ end of strcat
      ) ;_ end of action_tile 
    ) ;_  defun

    (a_n)



    (if	(action_tile "dln_dt" "")
      (setq dlndt "")
    ) ;_ end of if

    (action_tile
      "dl_ug"
      (strcat
	"(setq dlnug (get_tile \"dl_ug\"))"
	"(ukas)"
      ) ;_ end of strcat
    ) ;_ end of action_tile


    (defun a_dlndt (/)
      (action_tile
	"dln_dt"
	"(setq dlndt (get_tile \"dln_dt\"))"
      ) ;_ end of action_tile
    ) ;_  defun

    (a_dlndt)

    (defun notes ()
      (cond
	((and (or (eq pr_fl "0")
		  (eq pr_fl "1")
		  (eq pr_fl "2")

		  (eq pr_fl "5")
		  (eq pr_fl "6")
		  (eq pr_fl "7")
		  (eq pr_fl "8")
		  (eq pr_fl "9")
		  (eq pr_fl "10")
		  (eq pr_fl "11")
		  (eq pr_fl "12")
		  (eq pr_fl "13")
		  (eq pr_fl "14")
		  (eq pr_fl "15")
		  (eq pr_fl "16")
		  (eq pr_fl "3")
		  (eq pr_fl "4")
	      ) ;_ end of or
	      (eq spr "0")
	 ) ;_ end of and
	 (set_tile "help" " 1 .. ")
	)
	((and (or (eq pr_fl "0")
		  (eq pr_fl "1")
		  (eq pr_fl "2")
		  (eq pr_fl "5")
		  (eq pr_fl "6")
		  (eq pr_fl "7")
		  (eq pr_fl "8")
		  (eq pr_fl "16")
		  (eq pr_fl "3")
		  (eq pr_fl "4")
	      ) ;_ end of or
	      (eq spr "1")
	 ) ;_ end of and
	 (set_tile "help" " ")
	)
	((or (and (eq pr_fl "15")
		  (eq spr "1")
	     ) ;_ end of and
	     (and (eq pr_fl "16") (eq spr "2"))
	 ) ;_ end of or
	 (set_tile "help" " ")
	)
	((or (and (or (eq pr_fl "0")
		      (eq pr_fl "1")
		      (eq pr_fl "2")
		      (eq pr_fl "5")
		      (eq pr_fl "6")
		      (eq pr_fl "7")
		      (eq pr_fl "8")
		      (eq pr_fl "3")
		      (eq pr_fl "4")
		  ) ;_ end of or
		  (eq spr "2")
	     ) ;_ end of and
	     (and (or (eq pr_fl "9") (eq pr_fl "11") (eq pr_fl "12"))
		  (eq spr "1")
	     ) ;_  and
	 ) ;_ end of or
	 (set_tile "help" " ")
	)
	((and (or (eq pr_fl "10") (eq pr_fl "13") (eq pr_fl "14"))
	      (eq spr "1")
	 ) ;_  and
	 (set_tile "help" "  ")
	)
	((and (or (eq pr_fl "10") (eq pr_fl "13") (eq pr_fl "14"))
	      (eq spr "2")
	 ) ;_  and
	 (set_tile "help" "  ")
	)
	((and (eq pr_fl "16") (eq spr "2"))
	 (set_tile "help" " ")
	)
	((or (and (or (eq pr_fl "0")
		      (eq pr_fl "1")
		      (eq pr_fl "2")
		      (eq pr_fl "5")
		      (eq pr_fl "6")
		      (eq pr_fl "16")
		      (eq pr_fl "3")
		      (eq pr_fl "4")
		  ) ;_ end of or
		  (eq spr "3")
	     ) ;_ end of and
	     (and (eq pr_fl "15") (eq spr "2"))
	 ) ;_ end of or
	 (set_tile "help" " ")
	)
	((or (and (eq pr_fl "15")
		  (eq spr "3")
	     ) ;_ end of and
	     (and (eq pr_fl "16") (eq spr "4"))
	 ) ;_ end of or
	 (set_tile "help"
		   "    < >"
	 ) ;_  set_tile
	)
	((and (or (eq pr_fl "2")
		  (eq pr_fl "3")
		  (eq pr_fl "4")
		  (eq pr_fl "5")
	      ) ;_  or
	      (eq spr "4")
	 ) ;_  and
	 (set_tile "help" "  ")
	)
	((or (and (or (eq pr_fl "7")
		      (eq pr_fl "8")
		      (eq pr_fl "13")
		      (eq pr_fl "12")
		  ) ;_  or
		  (eq spr "4")
	     ) ;_  and
	     (and (or (eq pr_fl "11") (eq pr_fl "12")) (eq spr "3"))
	 ) ;_ end of or
	 (set_tile "help" "   < >")
	)
	((or (and (or (eq pr_fl "7") (eq pr_fl "8")) (eq spr "5"))
	     (and (or (eq pr_fl "11") (eq pr_fl "12")) (eq spr "4"))
	 ) ;_ end of or
	 (set_tile
	   "help"
	   "n = (b - s - R) / s -  .    s "
	 ) ;_ end of set_tile
	)
	((and (or (eq pr_fl "13") (eq pr_fl "14")) (eq spr "5"))
	 (set_tile
	   "help"
	   "n1 = (B - s - R) / s -  .    s "
	 ) ;_ end of set_tile
	)
	((and (or (eq pr_fl "13") (eq pr_fl "14")) (eq spr "6"))
	 (set_tile
	   "help"
	   "n2 = (b - s - R) / s -  .    s "
	 ) ;_ end of set_tile
	)
	((and (or (eq pr_fl "7") (eq pr_fl "8")) (eq spr "6"))
	 (set_tile
	   "help"
	   "n1 = (h - 2(R + s)) / s -  .   s "
	 ) ;_ end of set_tile
	)
	((or (and (or (eq pr_fl "0") (eq pr_fl "1") (eq pr_fl "6"))
		  (eq spr "4")
	     ) ;_  and
	     (and (or (eq pr_fl "9") (eq pr_fl "11") (eq pr_fl "12"))
		  (eq spr "2")
	     ) ;_  and
	     (and (or (eq pr_fl "7")
		      (eq pr_fl "8")
		      (eq pr_fl "10")
		      (eq pr_fl "13")
		      (eq pr_fl "14")
		  ) ;_  or
		  (eq spr "3")
	     ) ;_ end of and
	 ) ;_ end of or
	 (set_tile "help" " ")
	)
	((and (or (eq pr_fl "0")
		  (eq pr_fl "1")
		  (eq pr_fl "2")
		  (eq pr_fl "5")
		  (eq pr_fl "6")
		  (eq pr_fl "3")
		  (eq pr_fl "4")
	      ) ;_  or
	      (eq spr "5")
	 ) ;_ end of and
	 (set_tile "help" "    ")
	)
	((or (and (eq pr_fl "9") (eq spr "3"))
	     (and (eq pr_fl "10") (eq spr "4"))
	 ) ;_ end of or
	 (set_tile "help" "  ")
	)
	((or (and (or (eq pr_fl "0")
		      (eq pr_fl "1")
		      (eq pr_fl "2")
		      (eq pr_fl "5")
		      (eq pr_fl "6")
		      (eq pr_fl "3")
		      (eq pr_fl "4")
		  ) ;_  or
		  (eq spr "6")
	     ) ;_ end of and
	     (and (eq pr_fl "9") (eq spr "4"))
	     (and (eq pr_fl "10") (eq spr "5"))
	 ) ;_ end of or
	 (set_tile "help" "  ")
	)
	((or (and (or (eq pr_fl "0")
		      (eq pr_fl "1")
		      (eq pr_fl "2")
		      (eq pr_fl "5")
		      (eq pr_fl "6")
		      (eq pr_fl "7")
		      (eq pr_fl "8")
		      (eq pr_fl "13")
		      (eq pr_fl "14")
		      (eq pr_fl "3")
		      (eq pr_fl "4")
		  ) ;_ end of or
		  (eq spr "7")
	     ) ;_ end of and
	     (and (or (eq pr_fl "9")
		      (eq pr_fl "11")
		      (eq pr_fl "12")
		      (eq pr_fl "16")
		  ) ;_  or
		  (eq spr "5")
	     ) ;_  and
	     (and (eq pr_fl "10") (eq spr "6"))
	     (and (eq pr_fl "15") (eq spr "4"))
	     (and (eq pr_fl "16") (eq spr "5"))
	 ) ;_ end of or
	 (set_tile "help" "  ")
	)
	((or (and (or (eq pr_fl "0")
		      (eq pr_fl "1")
		      (eq pr_fl "2")
		      (eq pr_fl "5")
		      (eq pr_fl "6")
		      (eq pr_fl "7")
		      (eq pr_fl "8")
		      (eq pr_fl "13")
		      (eq pr_fl "14")
		      (eq pr_fl "3")
		      (eq pr_fl "4")
		  ) ;_ end of or
		  (eq spr "8")
	     ) ;_ end of and
	     (and (or (eq pr_fl "9") (eq pr_fl "11") (eq pr_fl "12"))
		  (eq spr "6")
	     ) ;_  and
	     (and (eq pr_fl "10") (eq spr "7"))
	     (and (eq pr_fl "15") (eq spr "5"))
	     (and (eq pr_fl "16") (eq spr "6"))
	 ) ;_ end of or
	 (set_tile "help" "    -")
	)
	((or (and (eq pr_fl "9") (eq spr "8")) ;_ end of and 
	     (and (or (eq pr_fl "11") (eq pr_fl "12")) (eq spr "10")) ;_ end of and 
	     (and (or (eq pr_fl "13") (eq pr_fl "14")) (eq spr "16")) ;_ end of and 
	 ) ;_ end of or
	 (set_tile "help" "    o-o")
	)
	((or (and (eq pr_fl "9") (eq spr "9")) ;_ end of and 
	     (and (or (eq pr_fl "11") (eq pr_fl "12")) (eq spr "11")) ;_ end of and 
	     (and (or (eq pr_fl "13") (eq pr_fl "14")) (eq spr "17")) ;_ end of and 
	 ) ;_ end of or
	 (set_tile "help" "    o-o")
	)
	((or (and (eq pr_fl "9") (eq spr "10")) ;_ end of and 
	     (and (or (eq pr_fl "11") (eq pr_fl "12")) (eq spr "12")) ;_ end of and
	     (and (or (eq pr_fl "13") (eq pr_fl "14")) (eq spr "18")) ;_ end of and 
	 ) ;_ end of or
	 (set_tile "help" "    Yo-Yo")
	)
	((and (eq pr_fl "10") (eq spr "13")) ;_ end of and  
	 (set_tile "help" "    Y1-Y1(min)")
	)
	((and (eq pr_fl "10") (eq spr "15")) ;_ end of and  
	 (set_tile "help" "    U-U(min)")
	)
	((or (and (eq pr_fl "9") (eq spr "11")) ;_ end of and 
	     (and (or (eq pr_fl "11") (eq pr_fl "12")) (eq spr "13")) ;_ end of and  
	     (and (or (eq pr_fl "13") (eq pr_fl "14")) (eq spr "19")) ;_ end of and 
	 ) ;_ end of or
	 (set_tile "help" "    Yo-Yo")
	)
	((and (eq pr_fl "10") (eq spr "16")) ;_ end of and  
	 (set_tile "help" "    U-U(min)")
	)
	((and (eq pr_fl "10") (eq spr "17")) ;_ end of and  
	 (set_tile "help" "    U-U")
	)
	((and (or (eq pr_fl "13") (eq pr_fl "14")) (eq spr "20")) ;_ end of and  
	 (set_tile "help" "    Yo-Yo")
	)
	((or (and (or (eq pr_fl "9") (eq pr_fl "13") (eq pr_fl "14"))
		  (eq spr "12")
	     ) ;_ end of and
	     (and (eq pr_fl "10") (eq spr "11"))
	     (and (or (eq pr_fl "11") (eq pr_fl "12")) (eq spr "14")) ;_ end of and 
	 ) ;_end of or 
	 (set_tile "help" "    X1-X1")
	)
	((or (and (or (eq pr_fl "11") (eq pr_fl "12")) (eq spr "15")) ;_ end of and
	     (and (or (eq pr_fl "13") (eq pr_fl "14")) (eq spr "14")) ;_ end of and
	 ) ;_ end of or
	 (set_tile "help" "    Y1-Y1")
	)
	((or (and (eq pr_fl "9") (eq spr "13")) ;_ end of and
	     (and (eq pr_fl "10") (eq spr "12"))
	     (and (eq pr_fl "10") (eq spr "14"))
	     (and (or (eq pr_fl "11") (eq pr_fl "12"))
		  (or (eq spr "16") (eq spr "17"))
	     ) ;_ end of and
	     (and (or (eq pr_fl "13") (eq pr_fl "14"))
		  (or (eq spr "13") (eq spr "15"))
	     ) ;_  and
	 ) ;_end of or  
	 (set_tile "help"
		   "       "
	 ) ;_ end of set_tile
	)
	((or (and (or (eq pr_fl "0")
		      (eq pr_fl "1")
		      (eq pr_fl "2")
		      (eq pr_fl "5")
		      (eq pr_fl "6")
		      (eq pr_fl "7")
		      (eq pr_fl "8")
		      (eq pr_fl "3")
		      (eq pr_fl "4")
		  ) ;_ end of or
		  (eq spr "9")
	     ) ;_ end of and
	     (and (eq pr_fl "15") (eq spr "7"))
	     (and (eq pr_fl "16") (eq spr "8"))
	 ) ;_end of or
	 (set_tile "help" "    -")
	)
	((or (and (or (eq pr_fl "0")
		      (eq pr_fl "1")
		      (eq pr_fl "2")
		      (eq pr_fl "5")
		      (eq pr_fl "6")
		      (eq pr_fl "7")
		      (eq pr_fl "8")
		      (eq pr_fl "3")
		      (eq pr_fl "4")
		  ) ;_ end of or
		  (eq spr "10")
	     ) ;_ end of and
	     (and (eq pr_fl "9") (eq spr "7"))
	     (and (eq pr_fl "16") (eq spr "10"))
	     (and (or (eq pr_fl "13") (eq pr_fl "14") (eq pr_fl "15"))
		  (eq spr "9")
	     ) ;_  and
	     (and (or (eq pr_fl "10") (eq pr_fl "11") (eq pr_fl "12"))
		  (eq spr "8")
	     ) ;_  and
	 ) ;_ end of or
	 (set_tile "help" "    -")
	)
	((and (or (eq pr_fl "0")
		  (eq pr_fl "1")
		  (eq pr_fl "2")
		  (eq pr_fl "5")
		  (eq pr_fl "6")
		  (eq pr_fl "7")
		  (eq pr_fl "8")
		  (eq pr_fl "3")
		  (eq pr_fl "4")
	      ) ;_ end of or
	      (eq spr "11")
	 ) ;_ end of and
	 (set_tile "help"
		   "     -"
	 ) ;_ end of set_tile
	)
	((or (and (or (eq pr_fl "0")
		      (eq pr_fl "1")
		      (eq pr_fl "2")
		      (eq pr_fl "5")
		      (eq pr_fl "6")
		      (eq pr_fl "7")
		      (eq pr_fl "8")
		      (eq pr_fl "3")
		      (eq pr_fl "4")
		  ) ;_ end of or
		  (eq spr "12")
	     ) ;_ end of and 
	     (and (eq pr_fl "10") (eq spr "9"))
	     (and (or (eq pr_fl "11") (eq pr_fl "12") (eq pr_fl "16"))
		  (eq spr "7")
	     ) ;_  and
	     (and (or (eq pr_fl "13") (eq pr_fl "14")) (eq spr "10"))
	     (and (eq pr_fl "15") (eq spr "6"))
	 ) ;_end of or
	 (set_tile "help" "    Y-Y")
	)
	((or (and (or (eq pr_fl "0")
		      (eq pr_fl "1")
		      (eq pr_fl "2")
		      (eq pr_fl "5")
		      (eq pr_fl "6")
		      (eq pr_fl "7")
		      (eq pr_fl "8")
		      (eq pr_fl "3")
		      (eq pr_fl "4")
		  ) ;_ end of or
		  (eq spr "13")
	     ) ;_ end of and
	     (and (eq pr_fl "15") (eq spr "8"))
	     (and (eq pr_fl "16") (eq spr "9"))
	 ) ;_end of or
	 (set_tile "help" "    Y-Y")
	)
	((or (and (or (eq pr_fl "0")
		      (eq pr_fl "1")
		      (eq pr_fl "2")
		      (eq pr_fl "5")
		      (eq pr_fl "6")
		      (eq pr_fl "7")
		      (eq pr_fl "8")
		      (eq pr_fl "3")
		      (eq pr_fl "4")
		  ) ;_ end of or
		  (eq spr "14")
	     ) ;_ end of and
	     (and (eq pr_fl "10") (eq spr "10"))
	     (and (or (eq pr_fl "11") (eq pr_fl "12")) (eq spr "9"))
	     (and (or (eq pr_fl "13") (eq pr_fl "14")) (eq spr "11"))
	     (and (eq pr_fl "15") (eq spr "10"))
	     (and (eq pr_fl "16") (eq spr "11"))
	 ) ;_end of or
	 (set_tile "help" "    Y-Y")
	)
	((and (or (eq pr_fl "5")
		  (eq pr_fl "6")
		  (eq pr_fl "7")
		  (eq pr_fl "8")
	      ) ;_  or
	      (eq spr "15")
	 ) ;_ end of and
	 (set_tile "help"
		   "   Y-Y    "
	 ) ;_ end of set_tile
	)
      ) ;_ end of cond
    ) ;_ end of defun

    (defun a_sprav (/)
      (action_tile
	"sprav"
	(strcat
	  "(setq spr (get_tile \"sprav\"))"
	  "(notes)"
	) ;_ end of strcat
      ) ;_ end of action_tile
    ) ;_  defun

    (a_sprav)

    (defun zakroy (/)
      (if
	(and (/= dlndt nil) (/= dlndt 0.0) (/= dlndt "") (/= dlndt " "))
	 (progn (done_dialog) (close x))
	 (alert "    L")
      ) ;_  if
    ) ;_  defun

    (defun a_accpt (/)
      (action_tile
	"accept"
	(strcat	"(progn (setq rr (get_tile \"n\"))"
		"(zakroy))"
	) ;_ end of strcat
      ) ;_  action_tile
    ) ;_  defun

    (a_accpt)


    (defun a_cncl (/)
      (action_tile
	"cancel"
	(strcat "(progn (setq rr nil)" "(done_dialog))" "(close x)")
      ) ;_ end of action_tile
    ) ;_  defun

    (a_cncl)


;;;;;;;;;;;;;;;;;;
    (defun prb ()

      (setq w (start_dialog))
     (if (= w 3)
	(progn
;;;	  (setvar "aperture" apsz)
;;;	  (setvar "osmode" osmd)
	  (setq	pt (getpoint "\n :")
		et (getpoint pt "\n :")
		di (rtos (distance pt et) 2 1)
	  ) ;_  setq
;;;	  (setvar "aperture" 1)
;;;	  (setvar "osmode" 0)
	  (if (not (new_dialog "dvtr3d" dcl_id))
	    (exit)
	  ) ;_  if

;;;------------------------------ 12.02.09  ----------------------------------
;;;      
    (start_list "s_l")
    (mapcar 'add_list sp_lay)
    (end_list)
     (if mark_p
       (set_tile "s_l"  mark_p )
       (set_tile "s_l" (itoa (vl-position *alan-layer-saved* sp_lay)))
     ) ;_  if
;;;------------------------------ 12.02.09    ------------------------------------------
	  (set_tile "dln_dt" di)
	  (setq dlndt (get_tile "dln_dt"))
	  (profil)
	  (a_prfl)
	  (a_n)
	  (set_tile "prfl" pr_fl)
	  (set_tile "n" rr)
	  (setq pr_fl (get_tile "prfl"))
	  (desk_f)
	  (whl)
	  (r_r)
	  (chart)
	  (show_im2 (name))
	  (a_sprav)
	  (hlp)
	  (a_dlndt)
	  (a_accpt)
	  (a_cncl)
;;;	  (setvar "aperture" apsz)
;;;	  (setvar "osmode" osmd)
	) ;_end of progn
      ) ;_end of if 
    ) ;_end of defun PRB
;;;;;;;;;;;;;;;;;;
    (action_tile "s_l" "(progn (setq mark_p $value))")
;;;------------------------------ 12.02.09  ----------------------------------

  
    (action_tile "ukz" "(done_dialog 3)") ;_ end of action_tile
    (prb)

    (while (= w 3) (action_tile "ukz" "(done_dialog 3)") (prb))



    (start_dialog)	      ;  
    (unload_dialog dcl_id)    ; DCL-
;;;------------------------------ 01.08.07  ----------------------------------
;;;   
;;;	    
    (setq *alan-layer-saved*
	   (if mark_p
	     (nth (atoi mark_p) sp_lay)
	     *alan-layer-saved*
	   ) ;_  if
    ) ;_  setq
;;;------------------------------ 01.08.07   ------------------------------------------
    (prin1)
  )			      ;   show 
  (show)
   (lay_o)
;;;------------------------------ 01.08.07  ----------------------------------
;;;        
  (setq	*alan-steel-saved-profile-type*
	 pr_fl
	*alan-steel-saved-profile-number*
	 rr
  ) ;_  setq
;;;    
;;; (setvar "osmode" 15359)
;;;      29.10.07    VVA 
    (setvar "osmode" 0)
        (setvar "clayer" *alan-layer-saved*)

;;;------------------------------ 01.08.07   ------------------------------------------

  (cond
    ((and (eq pr_fl "0") (/= rr nil))
     (dv_t_rp3d)
    )
    ((and (eq pr_fl "1") (/= rr nil))
     (dv_t_rp3d)
    )
    ((and (or (eq pr_fl "2") (eq pr_fl "3")) (/= rr nil))
     (dv_t_r3d)
    )
    ((and (or (eq pr_fl "5") (eq pr_fl "4")) (/= rr nil))
     (sv_l_r3d)
    )
    ((and (eq pr_fl "6") (/= rr nil))
     (sv_l_rp3d)
    )
    ((and (eq pr_fl "7") (/= rr nil))
     (sv_l_rg3d)
    )
    ((and (eq pr_fl "8") (/= rr nil))
     (sv_l_rg3d)
    )
    ((and (eq pr_fl "9") (/= rr nil))
     (ug_rp3d)
    )
    ((and (eq pr_fl "10") (/= rr nil))
     (ug_np3d)
    )
    ((and (eq pr_fl "11") (/= rr nil))
     (ug_rg3d)
    )
    ((and (eq pr_fl "12") (/= rr nil))
     (ug_rg3d)
    )
    ((and (eq pr_fl "13") (/= rr nil))
     (ug_ng3d)
    )
    ((and (eq pr_fl "14") (/= rr nil))
     (ug_ng3d)
    )
    ((and (eq pr_fl "15") (/= rr nil))
     (tr_prf3d)
    )
    ((and (eq pr_fl "16") (/= rr nil))
     (tr_prf3d)
    )
  ) ;_ end of cond 

;;;------------------------------ 01.08.07  ----------------------------------
;;;   
  (setvar "celtype" cltp)
  (setvar "cecolor" ccol)
  (setvar "cmdecho" cmd)
  (setvar "blipmode" blpm)
  (setvar "osmode" osmd)
  (setvar "clayer" clay)
;;;------------------------------ 01.08.07   ------------------------------------------
(vla-EndUndoMark (vla-get-activedocument (vlax-get-acad-object)))
  (prin1)

) ;_ end of defun
;;;--------------------------------------------------------------------------
(defun lay_o ( )
;;;    (command "_'layer" "_s" "0" "_c" "7" "" "")

  (command "_.Layer" "_T" "0" ; 
	   "_ON" "0"	      ;  
	   "_U"	"0"	      ;
	   "_S"	"0" ""	      ; 	
) ;_  command
 ;_  command
 ;_  command
  (princ)
) ;_ end of defun
;;;    kpblc.
(defun _kpblc-error-catch (protected-function
			   on-error-function
			   /
			   catch_error_result
			  )
			  ;|
***      ruCAD'a       ,
***  .
*      .
*     :
*	protected-function	- "" 
*	on-error-function	- ,    
|;
  (setq catch_error_result (vl-catch-all-apply protected-function))
  (if (and (vl-catch-all-error-p catch_error_result)
	   on-error-function
      ) ;_ end of and
    (apply on-error-function
	   (list (vl-catch-all-error-message catch_error_result))
    ) ;_ end of apply
    catch_error_result
  ) ;_ end of if
) ;_ end of defun

;;;   -    dwg.ru
(princ "\nURL: http://forum.dwg.ru/showthread.php?t=9322&page=23")
(princ "\n  (3d) .  - PRKT3D.  458  10.02.2009")
(princ)
;|Visual LISP Format Options
(72 2 30 2 T " " 72 9 1 1 0 T T nil T)
;***     ! ***|;
