(defun insert_shtamp(name)
  (command "_insert" name pause pause pause pause)
 );defun

(defun set_height_text(/ h)
  (if (not default_height_text) (setq default_height_text 1.25))
  (setq h (getreal (strcat "\n    <" (rtos default_height_text 2 3) ">: ")))
  (if (and h (> h 0)) (setq default_height_text h))
  (setvar "textsize" default_height_text)
  (princ)
 );defun

(defun set_decimal_number(/ h)
  (if (not default_decimal_number) (setq default_decimal_number 1))
  (setq h (getint (strcat "\n    <" (itoa default_decimal_number) ">: ")))
  (if h (setq default_decimal_number h))
  (princ)
 );defun

(defun set_twice_precision(/ h)
  (if (not twice_precision) (setq twice_precision 0.0))
  (setq h (getreal (strcat "\n         <" (rtos twice_precision 2 3) ">: ")))
  (if h (setq twice_precision h))
  (if (> twice_precision 1) (setq twice_precision 1.0))
  (princ)
 );defun

(defun set_truck_factor(/ h)
  (if (not truck_factor) (setq truck_factor 42.5))
  (setq h (getreal (strcat "\n    <" (rtos truck_factor 2 2) ">: ")))
  (if h (setq truck_factor h))
  (princ)
 );defun
