	(defun c:bmon (/
	           ss
	           mts
	           vl_mts
	           mask_on
	 
	           mt
	           mt_dxf
	           leader
	          )
	  (setq ss (ssget '((0 . "MTEXT"))));   
	  (setq mts (ssnamex ss))
	  (setq ss nil)
	  (setq mts (mapcar 'cadr mts));    
	  (setq mts (vl-remove-if-not '(lambda (x) (eq (type x) 'ENAME)) mts))   ;    
	 
	  (setq vl_mts (mapcar 'vlax-ename->vla-object mts))
	 
	  (mapcar '(lambda (x) (vla-put-BackgroundFill x :vlax-true)) vl_mts)
	 
	  (foreach mt mts
	    (setq mt_dxf (entget mt))
	    (setq mt_dxf (subst (cons 63 256) (assoc 63 mt_dxf) mt_dxf))
	    (setq mt_dxf (subst (cons 45 1) (assoc 45 mt_dxf) mt_dxf)) ; 1     
	    (setq mt_dxf (subst (cons 90 3) (assoc 90 mt_dxf) mt_dxf))
	    (entmod mt_dxf)
	    (if (assoc 330 mt_dxf)
	      (progn
	        (setq leader (cdr (assoc 330 mt_dxf)))
	    (vl-cmdf "_draworder" leader "" "_a" mt "")
	      )
	    )
	       
	  )
	)
	 
	 
	 
	(defun c:bmoff(/
	           ss
	           mts
	           vl_mts
	           mask_on
	 
	           mt
	           mt_dxf
	           leader
	          )
	  (setq ss (ssget '((0 . "MTEXT"))));   
	  (setq mts (ssnamex ss))
	  (setq ss nil)
	  (setq mts (mapcar 'cadr mts));    
	  (setq mts (vl-remove-if-not '(lambda (x) (eq (type x) 'ENAME)) mts))   ;    
	 
	  (setq vl_mts (mapcar 'vlax-ename->vla-object mts))
	 
	  (mapcar '(lambda (x) (vla-put-BackgroundFill x :vlax-false)) vl_mts)
	 
	)