(defun c:chtxt (/ adoc delta selset)
  (vl-load-com)
  (setq adoc (vla-get-activedocument (vlax-get-acad-object)))
  (vla-startundomark adoc)
  (if (and (setq delta (getreal "\n   <> : "))
           (setq selset (ssget '((0 . "*TEXT"))))
           ) ;_ end of and
    (foreach ent (mapcar 'vlax-ename->vla-object
                         (vl-remove-if 'listp (mapcar 'cadr (ssnamex selset)))
                         ) ;_ end of mapcar
      (if ((lambda (/ res)
             (mapcar '(lambda (x)
                        (if (vl-string-search x (vla-get-textstring ent))
                          (setq res t)
                          ) ;_ end of if
                        ) ;_ end of lambda
                     '("1" "2" "3" "4" "5" "6" "7" "8" "9" "0" "," ".")
                     ) ;_ end of mapcar
             res
             ) ;_ end of lambda
           )
        (vl-catch-all-apply
          '(lambda ()
             (vla-put-textstring
               ent
               (rtos
                 (+ (atof (vl-string-translate "," "." (vla-get-textstring ent)))
                    delta
                    ) ;_ end of +
                 ) ;_ end of rtos
               ) ;_ end of vla-put-TextString
             ) ;_ end of lambda
          ) ;_ end of vl-catch-all-apply
        ) ;_ end of if
      ) ;_ end of foreach
    ) ;_ end of if
  (vla-endundomark adoc)
  (princ)
  ) ;_ end of defun