	(defun c:datarl (/ ang len osm param pl pt1 pt2 tag vx1 vx2)
	  (vl-load-com)
	;;;   (setq |CMDECHO| (getvar "cmdecho"))
	  (setvar "cmdecho" 0)
	  ;(set osm (getvar "osmode"))
	  (setq pl (entsel "\n  /: "))
	  (setq pt1 (cadr pl)
	        pl    (vlax-ename->vla-object (car pl))
	        ) ;_ end of setq
	  (if (eq (vla-get-objectname pl) "AcDbLine")
	    ;;
	    (setq vx1 (vlax-safearray->list
	                (vlax-variant-value (vla-get-startpoint pl))
	                ) ;_ end of vlax-safearray->list
	          vx2 (vlax-safearray->list
	                (vlax-variant-value (vla-get-endpoint pl))
	                ) ;_ end of vlax-safearray->list
	          ) ;_ end of setq
	    (progn
	;;; pt1 -   
	;;;   
	      (setq pt1 (vlax-curve-getclosestpointto pl pt1))
	;;;    
	;;;   -  ,   0
	      (setq param (vlax-curve-getparamatpoint pl pt1))
	      (setq vx1 (vlax-curve-getpointatparam pl (fix param))) ;_ 
	      (setq vx2 (vlax-curve-getpointatparam pl (1+ (fix param)))) ;_ 
	      ) ;_ end of progn
	    ) ;_if
	  (setq ang (angtos (- (/ pi 2) (angle vx1 vx2)) 1 4))
	 ;_    -     -   .
	 ;_ :
	 ;_ 0 - 
	 ;_ 1 - , , 
	 ;_ 2 - 
	 ;_ 3 - 
	 ;_ 4 -   (   )
	  (setq ang (vl-string-subst "%%d" "d" ang))
	  (setq len (rtos (distance vx1 vx2) 2 3))
	  ;(setvar "osmode" 512)
	  (setq pt1 (getpoint "    : "))
	  (setq pt2 (getpoint pt1 "\n  : "))
	;;;Text data
	  (setq tag (strcat ang "\n(" len " )"))
	  (setq ang (angle pt1 pt2))
	;;;TEXT TO PRINT ON SCREEN
	  (entmake (list
	             (cons 0 "MTEXT")
	             (cons 100 "AcDbEntity")
	             (cons 100 "AcDbMText")
	             (cons 7 "Standart")
	             (cons 8 "-")
	             (cons 71 5)
	             (cons 72 5) ;  (5 - )
	             (cons 73 1)
	             (cons 10 pt1)
	;;;(cons 11 (list 1.0 0.0 0.0))
	             (cons 50 ang)
	;;;(cons 41 19.35)
	             (cons 40 (* 0.1 (strlen tag)))
	             (cons 44 1.0)
	             (cons 1 tag)
	             ) ;_ end of list
	           ) ;_ end of entmake
	  ;(setvar "osmode" osm)
	  (setvar "cmdecho" 1)
	  (redraw)
	  (princ)
	  ) ;_ end of defun