(defun c:g (/ poin_t)
  (while (setq poin_t (getpoint "   :"))
    (VL-CMDF "_vscurrent"
      "_h"
    )
    (entmakex
      (list
 '(0 . "POINT")
 '(100 . "AcDbEntity")
 '(370 . 0)
 '(100 . "AcDbPoint")
 (cons 10 (geo_z poin_t))
      )
    )
    (VL-CMDF "_vscurrent"
      "_2"
    )
  )
 
)
(defun geo_z (T1 / 3Df A B C dBx dBy dBz dCx dCy dCz dT1x dT1y Zx Zy)
  (setq 3Df  (ssget "_C"
      (polar t1 5.49778714 0.0001414214)
      (polar t1 2.35619449 0.0001414214)
      '((0 . "3DFACE"))
      )
 A    (CDR
        (ASSOC 11 (ENTGET (SSNAME 3Df 0)))
      )
 B    (CDR
        (ASSOC 12 (ENTGET (SSNAME 3Df 0)))
      )
 C    (CDR
        (ASSOC 13 (ENTGET (SSNAME 3Df 0)))
      )
 dBx  (- (nth 0 B) (nth 0 A))
 dBy  (- (nth 1 B) (nth 1 A))
 dBz  (- (nth 2 B) (nth 2 A))
 dCx  (- (nth 0 C) (nth 0 A))
 dCy  (- (nth 1 C) (nth 1 A))
 dCz  (- (nth 2 C) (nth 2 A))
 dT1x (- (nth 0 T1) (nth 0 A))
 dT1y (- (nth 1 T1) (nth 1 A))
 Zy   (/ (- (* dCz dBx) (* dCx dBz)) (- (* dBx dCy) (* dCx dBy))) ;_ Z  Y
 Zx   (/ (- dBz (* dBy Zy)) dBx) ;_ Z  X
 T1z  (+ (nth 2 A) (* dT1x Zx) (* dT1y Zy))
 t1   (list (nth 0 T1) (nth 1 T1) T1z)
  )
)