(defun C:kv (/ OLDVAR *adoc* s)
  ;;  
  (foreach x
   '("cmdecho" "plinewid" "osnapcoord" "osmode")
    (setq OLDVAR (cons (list x (getvar x)) OLDVAR))
  )
  (setq *adoc* (vla-get-ActiveDocument (vlax-get-acad-object)))
  (vla-StartUndoMark *adoc*)
  (setvar "cmdecho" 0)
  (setvar "plinewid" 0)
  (setvar "osnapcoord" 1)
  ;;  ,   "_nea,_end,_int,_per,"
  (foreach x '(512 1 32 128)
    (if (= 0 (logand x (getvar "osmode")))
      (setvar "osmode" (+ x (getvar "osmode")))
    )
  )
  ;;   
  (setvar "osmode" (logand -16385 (getvar "osmode")))
  ;;------------------------------------------
  ;;    .
  ;;   ,  
  ;;      
  ;;  .
  ;;     nil.
  ;;------------------------------------------
  (defun *realval* (VAL* / lst)
    (if
      (and VAL*
        (or
          (numberp VAL*) ;;   
          (numberp
            (setq VAL* ;;     c   ...
              (vl-catch-all-apply (function (lambda ()
                (read
                  (vl-list->string
                    (progn
                      ;;       
                      (setq lst (subst 46 44 (vl-remove '32 (vl-string->list VAL*))))
                      (cond
                        ;;    -    
                        ((not (member 46 lst))(append lst '(46 48)))
                        ;;     -    
                        ((= (car lst) 46)(cons 48 lst))
                        (T lst)
                      )
                    ) ;;...progn
                  ) ;;... vl-list->string
                ) ;;...read
              ))) ;;...vl-catch-all-apply
            ) ;;...setq
          ) ;;...numberp
        ) ;;...or
        (> VAL* 0) ;;   
      ) ;;...and
       VAL* ;;  - 
    ) ;;...if
  ) ;;...defun *realval*
  ;;----------------------------------
  ;;  
  ;;----------------------------------
  (princ "\n'\nU_:  (   )")
  (defun *go* (/ l h ptc pt1 pt2 pt3 pt4)
    ;;   
    (mapcar
      (function (lambda (param nval)
        (if (not (and (getenv param)(numberp (read (getenv param)))))
          (setenv param nval)
        )
      ))
     '("u_rrect_L" "u_rrect_H") '("10" "10")
    )
    ;;  ...
    (while
      ((lambda (/ xl)
        (princ (strcat "\n <" (getenv "u_rrect_L") ">: "))
        (initget 128)(setq xl (getreal))
        (cond
          ((not xl) nil)
          ((setq xl (*realval* xl))(setenv "u_rrect_L" (vl-princ-to-string xl)) nil)
          (T (alert "    !") T)
        )
      ))
    )
    (while
      ((lambda (/ xh)
        (princ (strcat "\n <" (getenv "u_rrect_H") ">: "))
        (initget 128)(setq xh (getreal))
        (cond
          ((not xh) nil)
          ((setq xh (*realval* xh))(setenv "u_rrect_H" (vl-princ-to-string xh)) nil)
          (T (alert "    !") T)
        )
      ))
    )
    (setq l   (read (getenv "u_rrect_L")) ;; 
          h   (read (getenv "u_rrect_H")) ;; 
          ptc (cadr (grread T 12))        ;;  (pickbox  4+8)
          pt1 (polar                      ;;  
                (polar ptc pi (* 0.5 l))
                (* 1.5 pi)
                (* 0.5 h)
              )
          pt2 (polar pt1 0 l)             ;;  
          pt3 (polar pt2 (* 0.5 pi) h)    ;;  
          pt4 (polar pt3 pi l)            ;;  
    )
    (vl-cmdf "_.PLINE" pt1 pt2 pt3 pt4 "_CL") ;;  
    (setq s (entlast)) ;;  -
    (mapcar (function princ)(list "\n'\n = " l "    = " h "    : "))
    ;;      (pickbox )
    (while (equal ptc (cadr (grread T 12))))
    (redraw s 2) ;;  
    ;;  
    (while s
      (vl-cmdf "_.MOVE" s "" ptc pause) ;;   
        ;;       ...
        (if (equal ptc (getvar "lastpoint"))
        (progn
          (entdel s)   ;;  
          (setq s nil) ;;  
        )
        (progn ;; ...
          (setq ptc (getvar "lastpoint")) ;;   
          (vl-cmdf "_.COPY" s "" ptc ptc) ;;   
          (princ "\n : ")
        )
      ) ;;...if equal
    ) ;;...while
  ) ;;...defun *go*
  ;;    
  (if (vl-catch-all-error-p (vl-catch-all-apply (function *go*)))
    (if s (entdel s))
  )
  (vla-EndUndoMark *adoc*)
  (foreach x OLDVAR (setvar (car x)(cadr x)))
  (princ)
)