(defun C:level (/ hgt po pt pts tpt txt x *error* adoc msht dmz mirr)
  (defun *error* (msg)
    (princ msg)
    (vla-endundomark adoc)
    (setvar "DIMZIN" dmz)
  ) ;_ end of defun
  (vl-load-com)
  (setvar "PLINEWID" 0)
  (vla-startundomark
    (setq adoc (vla-get-activedocument (vlax-get-acad-object)))
  ) ;_ end of vla-startundomark
  (setq dmz (getvar "DIMZIN"))
  (setvar "DIMZIN" 0)
  (if (null *OLMSHT*)
    (setq *OLMSHT* 1)
  ) ;_ end of if
  (if
    (progn
      (initget "G K   _    ")
      (= (getkword
    "\n    [/] :<> "
  ) ;_ end of getkword
  ""
      ) ;_ end of =
    ) ;_ end of progn
     (setq mirr -1)
     (setq mirr 1)
  ) ;_ end of if
  (and (or (initget 6 "1 10 20 50 100 1000") t)
       (princ "\nscale [1/10/20/50/100/500/1000] <")
       (princ *OLMSHT*)
       (princ ">: ")
       (or (setq msht (getdist)) (setq msht *OLMSHT*))
       (setq *OLMSHT* msht)
       (or (vl-propagate '*OLMSHT*) t)
       (setq msht (/ msht 100.0))
       (setq po (getpoint "\nSpecify o.oo point: "))
       (setq hgt (getvar "TEXTSIZE"))
       (while (setq pt (getpoint "\nSpecify next point (Enter for esc):"))
  (setq txt (rtos (setq pts (* msht (- (cadr pt) (cadr po)))) 2 3))
  (if (and (not (minusp pts)) (not (zerop pts)))
    (setq txt (strcat "+" txt))
  ) ;_ end of if
  (if (not (vl-string-search "." txt))
    (setq txt (strcat txt ".00"))
  ) ;_ end of if
  (setq pts (list pt
    (mapcar '+ pt (list 0 (* hgt 0.6) 0)) ;_hgt of arrow
    (mapcar '+ pt (list 0 (* hgt 1.75) 0)) ;_Vert line
    (mapcar '+ pt (list (* mirr hgt 3.5) (* hgt 1.75) 0))
     ) ;_Horizont line
        tpt (mapcar '+ pt (list (* mirr hgt 1.75) (* hgt 2.0) 0))
  ) ;_ end of setq
  (entmakex (list
       '(0 . "LINE")
       '(100 . "AcDbEntity")
       (cons 410 (getvar "CTAB"))
       (cons 8 (getvar "CLAYER"))
       '(100 . "AcDbLine")
       (cons 62 256)
       (cons 10 (trans (polar pt PI (* hgt 0.9)) 1 0))
       (cons 11 (trans (polar pt 0 (* hgt 0.9)) 1 0))
     ) ;_ end of list
  ) ;_ end of entmake
  (entmakex
    (append (list
       '(0 . "LWPOLYLINE")
       '(100 . "AcDbEntity")
       (cons 410 (getvar "CTAB"))
       (cons 8 (getvar "CLAYER"))
       '(100 . "AcDbPolyline")
       (cons 62 256)
       (cons 90 (length pts))
       (cons 70 0)
       (cons 43 0.0)
     ) ;_ end of list
     (mapcar '(lambda (x) (cons 10 x))
      (mapcar '(lambda (x) (trans x 1 0)) pts)
     ) ;_ end of mapcar
    ) ;_ end of append
  ) ;_ end of entmake
  (vla-setwidth
    (vlax-ename->vla-object (entlast))
    0
    0.0
    (* hgt 2)
  ) ;_ end of vla-setwidth
  (entmakex (list '(0 . "TEXT")
    (cons 10 (trans tpt 1 0))
    (cons 11 (trans tpt 1 0))
    (cons 410 (getvar "CTAB"))
    (cons 8 (getvar "CLAYER"))
    (cons 7 (getvar "TEXTSTYLE"))
    (cons 62 256)
    (cons 40 hgt)
    (cons 50 0.0)
    (cons 1 txt)
    (cons 72 1)
     ) ;_ end of list
  ) ;_ end of entmake
       ) ;_ end of while
  ) ;_ end of and
  (setvar "DIMZIN" dmz)
  (vla-endundomark adoc)
  (princ)
) ;_ end of defun
(princ "\n >>> Insert levels Command: level")
(princ)