;;;-------------------------------->DDLR-MERGE<------------------------------------;;;
;;;                                                                    ;;;
;;;                            LMRG.lsp Version 1.32                               ;;;
;;;                           :                                ;;;
;;;    :                                               ;;;
;;; LR-MERGE:            ;;;
;;; .   .                                              ;;;
;;; DDLR-MERGE:                   ;;;
;;;  .   (ddlmrg.dcl).                             ;;;
;;;--------------------------------------------------------------------------------;;;

;;;   
(DEFUN LR-MRG-MAIN (ln nln optbit / col1 col2 lt1 lt2 lwt1 lwt2 i blkd ss0 en ed
      CHECK-BLOCK BLKREDEFMRG ATTREDEFMRG VPREDEFMRG)

   ;;;    ,   
   (DEFUN CHECK-BLOCK (blkd ln / en ed flag)
      (SETQ
         en (CDR (ASSOC -2 blkd));   
         flag nil
         );SETQ
      (IF (= (LOGAND (CDR (ASSOC 70 blkd)) 1) 1); 
         (SETQ flag nil)
         (WHILE en
            (SETQ ed (ENTGET en));   
            (IF (= (STRCASE (CDR (ASSOC 8 ed))) (STRCASE ln))
               (SETQ
                  flag T
                  en nil)
               (SETQ en (ENTNEXT en));  . 
               );IF
            );WHILE
         );IF
      flag
      );DEFUN

   ;;;   (  Express Tools)
   (DEFUN ATTREDEFMRG ( / fltr ss cnt en ilay elst doit laylck
         LAYER-LOCKED)

      ;;;     (  Bonus Tools)
      (DEFUN LAYER-LOCKED (ln / en ed)
         (SETQ en (TBLOBJNAME "LAYER" ln)
            ed (ENTGET en)
            );SETQ
         (EQUAL 4
            (LOGAND 4 (CDR (ASSOC 70 ed)))
            );EQUAL
         );DEFUN

      (SETQ fltr (LIST '(0 . "INSERT") '(66 . 1))
         ss   (SSGET "_X" fltr)
         cnt  0
         );SETQ
      (WHILE (AND ss
            (> (SSLENGTH ss) 0)
            (SETQ en (SSNAME ss cnt))
            );AND
         (SETQ ed   (ENTGET en '("*"))
            ilay (CDR (ASSOC 8 ed))
            elst (LIST ed)
            doit nil
            );SETQ
         (WHILE (/= "SEQEND" (CDR (ASSOC 0 (ENTGET (SETQ en (ENTNEXT en))))))
            (SETQ ed (ENTGET en '("*")))
            (IF (/= ln (CDR (ASSOC 8 ed)))
               (SETQ elst (CONS ed elst))
               (PROGN
                  (SETQ ed   (SUBST (CONS 8 nln) (ASSOC 8 ed) ed))
                  (IF (AND (= (LOGAND optbit 2) 2) (/= col1 col2)
                        (OR (NULL (ASSOC 62 ed))
                           (= (CDR (ASSOC 62 ed)) 256)
                           (= (CDR (ASSOC 62 ed)) -256)
                           );OR
                        );AND
                     (IF (ASSOC 62 ed)
                        (SETQ ed (SUBST (CONS 62 col1) (ASSOC 62 ed) ed)); 
                        (SETQ ed (APPEND ed (LIST (CONS 62 col1)))); 
                        );IF
                     );IF
                  (IF (AND (= (LOGAND optbit 4) 4) (/= lt1 lt2)
                        (OR (NULL (ASSOC 6 ed))
                           (EQ (STRCASE (CDR (ASSOC 6 ed))) "BYLAER")
                           );OR
                        );AND
                     (IF (ASSOC 6 ed)
                        (SETQ ed (SUBST (CONS 6 lt1) (ASSOC 6 ed) ed));  
                        (SETQ ed (APPEND ed (LIST (CONS 6 lt1))));  
                        );IF
                     );IF
                  (IF (AND (= (LOGAND optbit 8) 8) (/= lwt1 lwt2) (ASSOC 370 (ENTGET (TBLOBJNAME "LAYER" ln)))
                        (OR (NULL (ASSOC 370 ed))
                           (= (CDR (ASSOC 370 ed)) -1)
                           );OR
                        );AND
                     (IF (ASSOC 370 ed)
                        (SETQ ed (SUBST (CONS 370 lwt1) (ASSOC 370 ed) ed));  
                        (SETQ ed (APPEND ed (LIST (CONS 370 lwt1))));  
                        );IF
                     );IF
                  (SETQ elst (CONS ed elst)
                     doit T
                     );SETQ
                  );PROGN
               );IF
            );WHILE
         (SETQ elst (REVERSE elst)
            ed   (ENTGET en '("*"))
            );SETQ
         (IF (< 1 (LENGTH elst))
            (IF (OR doit (= ln (CDR (ASSOC 8 ed))))
               (PROGN
                  (ENTMAKE)
                  (FOREACH mbr elst (ENTMAKE mbr))
                  (ENTMAKE (SUBST (CONS 8 ilay) (ASSOC 8 ed) ed))
                  (ENTDEL (CDR (ASSOC -1 (CAR elst))))
                  );PROGN
               );IF
            (PROGN
               (ENTMAKE)
               (ENTMAKE (SUBST (CONS 66 0) (ASSOC 66 (CAR elst)) (CAR elst)))
               (IF (SETQ laylck (LAYER-LOCKED (CDR (ASSOC 8 (CAR elst)))))
                  (COMMAND "_.-layer" "_u" (CDR (ASSOC 8 (CAR elst))) "")
                  );IF
               (ENTDEL (CDR (ASSOC -1 (CAR elst))))
               (IF laylck (COMMAND "_.-layer" "_lo" (CDR (ASSOC 8 (CAR elst))) ""))
               );PROGN
            );IF
         (SETQ cnt (1+ cnt))
         );WHILE
      );DEFUN

   ;;;      
   (DEFUN VPREDEFMRG ( / ss0 lwt tilemode-save ctab-save)
      (SETQ ss0 (SSGET "_X" (LIST '(0 . "VIEWPORT") (CONS 8  ln)))
         i 0
         tilemode-save (GETVAR "TILEMODE")
         );SETQ
      (IF (NOT (NULL ss0))
         (PROGN
            (WHILE (<= i (- (SSLENGTH ss0) 1))
               (SETQ en (SSNAME ss0 i)
                  ed (ENTGET en)
                  ctab-save (GETVAR "CTAB")
                  );SETQ
               (IF (ASSOC 410 ed)
                  (SETVAR "CTAB" (CDR (ASSOC 410 ed)))
                  );IF   
               (SETVAR "TILEMODE" 0) 
               (COMMAND "_.pspace"
                  "_.vplayer" "_Thaw" ln "" ""
                  "_.vplayer" "_Thaw" nln "" ""
                  "_.chprop" en "" "_layer" nln ""
                  );COMMAND    
               (IF (AND (= (LOGAND optbit 2) 2) (/= col1 col2)
                     (OR (NULL (ASSOC 62 ed))
                        (= (CDR (ASSOC 62 ed)) 256)
                        (= (CDR (ASSOC 62 ed)) -256)
                        );OR
                     );AND
                  (COMMAND "_.chprop" en "" "_color" col1 "")
                  );IF
               (IF (AND (= (LOGAND optbit 4) 4) (/= lt1 lt2)
                     (OR (NULL (ASSOC 6 ed))
                        (EQ (STRCASE (CDR (ASSOC 6 ed))) "BYLAER")
                        );OR
                     );AND
                  (COMMAND "_.chprop" en "" "_ltype" lt1 "")
                  );IF
               (IF (AND (= (LOGAND optbit 8) 8) (/= lwt1 lwt2) (ASSOC 370 (ENTGET (TBLOBJNAME "LAYER" ln)))
                     (OR (NULL (ASSOC 370 ed))
                        (= (CDR (ASSOC 370 ed)) -1)
                        );OR
                     );AND
                  (PROGN 
                     (IF (= lwt1 -3) 
                        (SETQ lwt "_default")
                        (SETQ lwt (/ lwt1 100.0))
                        );IF  
                     (COMMAND "_.chprop" en "" "_lweight" lwt "")
                     );PROGN
                  );IF
               (IF (ASSOC 410 ed)
                  (SETVAR "CTAB" ctab-save)
                  );IF   
               (SETQ i (1+ i))        
               );WHILE
            (SETVAR "TILEMODE" tilemode-save)     
            );PROGN
         );IF         
      );DEFUN   

   ;;;   (  Express Tools)
   (DEFUN BLKREDEFMRG (bnam / blk en ed)
      (ENTMAKE)
      (SETQ blk (ENTGET (TBLOBJNAME "BLOCK" bnam)'("*"))
         blk (SUBST (CONS 8 "0") (ASSOC 8 blk) blk)
         en  (CDR (ASSOC -2 blk))
         );SETQ
      (ENTMAKE blk);  
      (WHILE en ;  
         (SETQ ed (ENTGET en '("*")))
         (IF (= (STRCASE (CDR (ASSOC 8 ed))) (STRCASE ln))
            (PROGN
               (SETQ ed (SUBST (CONS 8 nln) (ASSOC 8 ed) ed));   
               (IF (AND (= (LOGAND optbit 2) 2) (/= col1 col2)
                     (OR (NULL (ASSOC 62 ed))
                        (= (CDR (ASSOC 62 ed)) 256)
                        (= (CDR (ASSOC 62 ed)) -256)
                        );OR
                     );AND
                  (IF (ASSOC 62 ed)
                     (SETQ ed (SUBST (CONS 62 col1) (ASSOC 62 ed) ed)); 
                     (SETQ ed (APPEND ed (LIST (CONS 62 col1)))); 
                     );IF
                  );IF
               (IF (AND (= (LOGAND optbit 4) 4) (/= lt1 lt2)
                     (OR (NULL (ASSOC 6 ed))
                        (EQ (STRCASE (CDR (ASSOC 6 ed))) "BYLAER")
                        );OR
                     );AND
                  (IF (ASSOC 6 ed)
                     (SETQ ed (SUBST (CONS 6 lt1) (ASSOC 6 ed) ed));  
                     (SETQ ed (APPEND ed (LIST (CONS 6 lt1))));  
                     );IF
                  );IF
               (IF (AND (= (LOGAND optbit 8) 8) (/= lwt1 lwt2) (ASSOC 370 (ENTGET (TBLOBJNAME "LAYER" ln)))
                     (OR (NULL (ASSOC 370 ed))
                        (= (CDR (ASSOC 370 ed)) -1)
                        );OR
                     );AND
                  (IF (ASSOC 370 ed)
                     (SETQ ed (SUBST (CONS 370 lwt1) (ASSOC 370 ed) ed));  
                     (SETQ ed (APPEND ed (LIST (CONS 370 lwt1))));  
                     );IF
                  );IF
               (ENTMAKE ed);    
               );PROGN
            (ENTMAKE ed)
            );IF
         (SETQ en   (ENTNEXT en))
         );WHILE
      (SETQ bnam (ENTMAKE (LIST (CONS 0 "endblk")))); 
      );DEFUN

   ;;;  
   (PRINC "\n...\n")
   (COMMAND "_.-layer" "_ON" ln
      "_Thaw" ln
      "_Unlock" ln
      "_ON" nln
      "_Thaw" nln
      "_Unlock" nln
      ""
      );COMMAND 
   (SETQ 
      col1 (ABS (CDR (ASSOC 62 (TBLSEARCH "LAYER" ln))))
      col2 (ABS (CDR (ASSOC 62 (TBLSEARCH "LAYER" nln))))
      lt1 (CDR (ASSOC 6 (TBLSEARCH "LAYER" ln)))
      lt2 (CDR (ASSOC 6 (TBLSEARCH "LAYER" nln)))
      lwt1 (CDR (ASSOC 370 (ENTGET (TBLOBJNAME "LAYER" ln))))
      lwt2 (CDR (ASSOC 370 (ENTGET (TBLOBJNAME "LAYER" nln))))
      );SETQ
   (ATTREDEFMRG)
   (VPREDEFMRG)
   (SETQ ss0 (SSGET "_X" (LIST (CONS 8  ln)))
      i 0);SETQ      
   (IF (NOT (NULL ss0))
      (PROGN
         (IF (OR (EQ (STRCASE ln) (STRCASE "Defpoints"))
               (EQ ln "0")
               );OR
            (PRINC (STRCAT "\n    \""
                  ln
                  "\"  ."
                  "\n     \""
                  ln
                  "\"   \""
                  nln
                  "\". "
                  );STRCAT
               );PRINC
            );IF
         (WHILE (<= i (- (SSLENGTH ss0) 1))
            (SETQ ed (ENTGET (SSNAME ss0 i))
               ed (SUBST (CONS 8 nln) (ASSOC 8 ed) ed); 
               );SETQ
            (IF (AND (= (LOGAND optbit 2) 2) (/= col1 col2)
                  (OR (NULL (ASSOC 62 ed))
                     (= (CDR (ASSOC 62 ed)) 256)
                     (= (CDR (ASSOC 62 ed)) -256)
                     );OR
                  );AND
               (IF (ASSOC 62 ed)
                  (SETQ ed (SUBST (CONS 62 col1) (ASSOC 62 ed) ed)); 
                  (SETQ ed (APPEND ed (LIST (CONS 62 col1)))); 
                  );IF
               );IF
            (IF (AND (= (LOGAND optbit 4) 4) (/= lt1 lt2)
                  (OR (NULL (ASSOC 6 ed))
                     (EQ (STRCASE (CDR (ASSOC 6 ed))) "BYLAER")
                     );OR
                  );AND
               (IF (ASSOC 6 ed)
                  (SETQ ed (SUBST (CONS 6 lt1) (ASSOC 6 ed) ed));  
                  (SETQ ed (APPEND ed (LIST (CONS 6 lt1))));  
                  );IF
               );IF
            (IF (AND (= (LOGAND optbit 8) 8) (/= lwt1 lwt2) (ASSOC 370 (ENTGET (TBLOBJNAME "LAYER" ln)))
                  (OR (NULL (ASSOC 370 ed))
                     (= (CDR (ASSOC 370 ed)) -1)
                     );OR
                  );AND
               (IF (ASSOC 370 ed)
                  (SETQ ed (SUBST (CONS 370 lwt1) (ASSOC 370 ed) ed));  
                  (SETQ ed (APPEND ed (LIST (CONS 370 lwt1))));  
                  );IF
               );IF
            (ENTMOD ed)
            (SETQ i (1+ i))
            );WHILE
         );PROGN
      );IF
   (IF (= (LOGAND optbit 1) 1)
      (PROGN
         (SETQ blkd (TBLNEXT "BLOCK" T));SETQ
         (WHILE blkd
            (IF (CHECK-BLOCK blkd ln)
               (BLKREDEFMRG (CDR (ASSOC 2 blkd)))
               );IF
            (SETQ blkd (TBLNEXT "BLOCK"))
            );WHILE
         );PROGN
      );IF
   (IF (EQ (STRCASE (GETVAR "CLAYER")) (STRCASE ln))
      (SETVAR "CLAYER" "0")
      );IF
   (IF (NOT (OR (EQ (STRCASE ln) (STRCASE "Defpoints"))
            (EQ ln "0"));OR
         );NOT
      (COMMAND "_.PURGE" "_LAyers" ln "_No")
      );IF
   (COMMAND "_.REGENALL")
   (SETQ *error* error-save)
   (PRINC)
   );DEFUN

;;; 
;;;  
(DEFUN LR-MERGE (/ ln nln error-save ans blockflag colflag ltflag lwtflag optbit)
   (SETQ cmdecho-save (GETVAR "CMDECHO")
      error-save *error*
      );SETQ
   (DEFUN *error* (msg)
      (IF  error-save (SETQ *error* error-save))
      (IF msg (PRINC "\n   "))
      (PRINC)
      );DEFUN
   (SETVAR "CMDECHO" 0)
   (COMMAND "_.undo" "_begin")
   (SETQ ln (GETSTRING "\n   : ")
      optbit 0);SETQ
   (WHILE (NOT (TBLSEARCH "LAYER" ln))
      (PRINC "\n c  \"")
      (PRINC ln)
      (PRINC "\"  .")
      (SETQ ln (GETSTRING "\n   : "))
      );WHILE
   (SETQ nln (GETSTRING "\n   : ")
      optbit 0);SETQ
   (WHILE (NOT (TBLSEARCH "LAYER" nln))
      (PRINC "\n c  \"")
      (PRINC nln)
      (PRINC "\"  .")
      (SETQ nln (GETSTRING "\n   : "))
      );WHILE
   (SETQ ln (STRCASE ln)
      nln (STRCASE nln)
      );SETQ
   (INITGET "Yes No")
   (SETQ ans (GETKWORD "\n ? (Yes/N) <N>: ")
      blockflag (= ans "Yes"));SETQ
   (INITGET "Yes No")
   (SETQ ans (GETKWORD "\n ? (Yes/N) <N>: ")
      colflag (= ans "Yes"));SETQ
   (INITGET "Yes No")
   (SETQ ans (GETKWORD "\n  ? (Yes/N) <N>: ")
      ltflag (= ans "Yes"));SETQ
   (IF (ASSOC 370 (ENTGET (TBLOBJNAME "LAYER" "0")))
      (PROGN
         (INITGET "Yes No")
         (SETQ ans (GETKWORD "\n  ? (Yes/N) <N>: ")
            lwtflag (= ans "Yes"));SETQ
         );PROGN
      );IF
   (IF blockflag (SETQ optbit (+ optbit 1)))
   (IF colflag (SETQ optbit (+ optbit 2)))
   (IF ltflag (SETQ optbit (+ optbit 4)))
   (IF lwtflag (SETQ optbit (+ optbit 8)))
   (LR-MRG-MAIN ln nln optbit)
   (COMMAND "_.undo" "_end")
   (SETQ *error* error-save)
   (SETVAR "cmdecho" cmdecho-save)
   (PRINC)
   );DEFUN

;;; 
;;; 
(DEFUN DDLR-MERGE (/ ln nln error-save cmdecho-save optbit lrlst
      dcl_id dialogLoaded dialogShow userclick)

   ;;      
   (DEFUN SHOW-LATR (ln basic / col lt wdth hght)
      (SETQ 
         col (ABS (CDR (ASSOC 62 (TBLSEARCH "LAYER" ln))))
         lt (CDR (ASSOC 6 (TBLSEARCH "LAYER" ln)))
         );SETQ
      (IF basic
         (PROGN
            (SETQ wdth (DIMX_TILE  "lm_col1")
               hght (DIMY_TILE "lm_col1"))
            (START_IMAGE "lm_col1")
            (FILL_IMAGE 0 0 wdth hght col) 
            (END_IMAGE)
            (SET_TILE "lm_lt1" lt)
            );PROGN
         (PROGN
            (SETQ wdth (DIMX_TILE  "lm_col2")
               hght (DIMY_TILE "lm_col2"))
            (START_IMAGE "lm_col2")
            (FILL_IMAGE 0 0 wdth hght col) 
            (END_IMAGE)
            (SET_TILE "lm_lt2" lt)
            );PROGN
         );IF
      );DEFUN   

   (SETQ cmdecho-save (GETVAR "CMDECHO")
      error-save *error*
      );SETQ
   (DEFUN *error* (msg)
      (IF  error-save (SETQ *error* error-save))
      (IF msg (PRINC "\n   "))
      (PRINC)
      );DEFUN
   (SETVAR "CMDECHO" 0)
   (COMMAND "_.undo" "_begin")
   (SETQ dialogLoaded T
      dialogShow T
      );SETQ
;;  
   (IF (= -1 (SETQ dcl_id (LOAD_DIALOG "ddlmrg.dcl")))
      (PROGN
         (PRINC "\n   ddlmrg.dcl")
         (SETQ dialogLoaded nil)
         );PROGN
      );IF
;;  
   (IF (AND dialogLoaded
         (NOT (NEW_DIALOG "lm_box1" dcl_id))
         );AND
      (PROGN
         (PRINC "\n   lm_box1")
         (SETQ dialogShow nil)
         );PROGN
      );IF
;;  
   (SETQ lrlst nil)
   (IF (AND dialogLoaded dialogShow)
      (PROGN
         (SETQ ln (TBLNEXT "LAYER" T));SETQ
         (WHILE ln
            (SETQ lrlst (CONS (CDR (ASSOC 2 ln)) lrlst)
               ln (TBLNEXT "LAYER"))
            );WHILE
         (REVERSE lrlst)
         (START_LIST "lm_layer")
         (MAPCAR 'ADD_LIST lrlst)
         (END_LIST)
         (START_LIST "lm_newlayer")
         (MAPCAR 'ADD_LIST lrlst)
         (END_LIST)
         (SHOW-LATR (NTH (ATOI (GET_TILE "lm_layer")) lrlst) T)
         (SHOW-LATR (NTH (ATOI (GET_TILE "lm_newlayer")) lrlst) nil)
         (IF *blockflag
            (SET_TILE "lm_block" "1")
            );IF
         (IF *colflag
            (SET_TILE "lm_col" "1")
            );IF
         (IF *ltflag
            (SET_TILE "lm_ltype" "1")
            );IF
         (IF *lwtflag
            (SET_TILE "lm_lwt" "1")
            );IF
         (IF (ASSOC 370 (ENTGET (TBLOBJNAME "LAYER" "0")))
            (MODE_TILE "lm_lwt" 0)
            (MODE_TILE "lm_lwt" 1)
            );IF
         );PROGN
      );IF
;;   
   (ACTION_TILE "lm_layer" "(SHOW-LATR (NTH (ATOI (GET_TILE \"lm_layer\")) lrlst) T)")
   (ACTION_TILE "lm_newlayer" "(SHOW-LATR (NTH (ATOI (GET_TILE \"lm_newlayer\")) lrlst) nil)")
   (ACTION_TILE "lm_block" "(SETQ *blockflag (= (GET_TILE \"lm_block\") \"1\"))")
   (ACTION_TILE "lm_col" "(SETQ *colflag (= (GET_TILE \"lm_col\") \"1\"))")
   (ACTION_TILE "lm_ltype" "(SETQ *ltflag (= (GET_TILE \"lm_ltype\") \"1\"))")
   (ACTION_TILE "lm_lwt" "(SETQ *lwtflag (= (GET_TILE \"lm_lwt\") \"1\"))")
   (ACTION_TILE "cancel" "(DONE_DIALOG) (SETQ userclick 0)")
   (ACTION_TILE "accept"
      (STRCAT "(PROGN (SETQ ln (NTH (ATOI (GET_TILE \"lm_layer\")) lrlst))"
         "(SETQ nln (NTH (ATOI (GET_TILE \"lm_newlayer\")) lrlst))"
         "(DONE_DIALOG) (SETQ userclick 1))"
         );STRCAT
      );ACTION_TILE
   (START_DIALOG)
   (UNLOAD_DIALOG dcl_id)
   (COND ((= userclick 1)
         (SETQ optbit 0
            ln (STRCASE ln)
            nln (STRCASE nln)
            );SETQ
         (IF *blockflag (SETQ optbit (+ optbit 1)))
         (IF *colflag (SETQ optbit (+ optbit 2)))
         (IF *ltflag (SETQ optbit (+ optbit 4)))
         (IF *lwtflag (SETQ optbit (+ optbit 8)))
         (LR-MRG-MAIN ln nln optbit)
         );1
      );COND
   (COMMAND "_.undo" "_end")
   (SETQ *error* error-save)
   (SETVAR "cmdecho" cmdecho-save)
   (PRINC)
   );DEFUN

(IF (OR (NULL C:DDLR-MERGE)
      (NOT (LISTP C:DDLR-MERGE))
      );OR
   (DEFUN C:DDLR-MERGE ()
      (DDLR-MERGE)
      );DEFUN
   );IF
(IF (OR (NULL C:LR-MERGE)
      (NOT (LISTP C:LR-MERGE))
      );OR
   (DEFUN C:LR-MERGE ()
      (LR-MERGE)
      );DEFUN
   );IF
(PRINC "\nLMrg.lsp ... ")
(PRINC "\n  DDLR-MERGE...")
(PRINC "\n  LR-MERGE...")
(PRINC)