(defun c:mrott(/ CUROBJ MAXPT MINPT MIPT MNPT MXPT OLDANG VLAOBJ)
  (vl-load-com)
  (if(not blrot:ang)(setq blrot:ang (/ pi 2)))
  (setq oldAng blrot:ang curObj(entlast))
  (if(null blrot:ang)(setq blrot:ang oldAng))
  (while curObj
    (setq curObj(car(entsel "\nSelect object to Rotate ")))
    (if curObj
      (progn
        (setq vlaObj(vlax-ename->vla-object curObj))
        (vla-GetBoundingBox vlaObj 'MinPt 'MaxPt)
        (setq mnPt(vlax-safearray->list MinPt)
          mxPt(vlax-safearray->list MaxPt)
          miPt(list(+(car mnPt)(/(-(car mxPt)(car mnPt))2))
          (+(cadr mnPt)(/(-(cadr mxPt)(cadr mnPt))2))0.0)
        ); end setq
        (if (vl-catch-all-error-p
     (vl-catch-all-apply 'vla-rotate (list vlaObj(vlax-3D-Point miPt)blrot:ang)))
          (princ "\nObject on locked layer!")
        ); end if
      ); end progn
    ); end if
  ); end while
  (princ)
);defun