(defun C:pol3point ( / *error* pt1 pt2 pt1W pt2W ucs ucf osm isRus)
  (defun *error* (msg)(princ msg)
    (if ucs (command "_.UCS" "_P")) ;_ end of if
    (if osm (setvar "OSMODE" osm)) ;_ end of if
    (setvar "UCSFOLLOW" ucf)(vla-endundomark *kpblc-activedoc*)
    (princ)) ;_ end of defun
  (vl-load-com)
(or *kpblc-activedoc* (setq *kpblc-activedoc* (vla-get-activedocument (vlax-get-acad-object))))
(setvar "CMDECHO" 0)
(vla-startundomark *kpblc-activedoc*)
  
  (setq isRus (= (getvar "DWGCODEPAGE") "ANSI_1251")
          ucf (getvar "UCSFOLLOW"))
  (setvar "UCSFOLLOW" 0)
  (initget 1)
  (setq pt1 (getpoint
              (if isRus
                "\n  :"
                "\nThe first point of a rectangular:"
              ) ;_ end of if
            ) ;_ end of getpoint
  ) ;_ end of setq
  (initget 1)
  (setq pt2 (getpoint pt1
                      (if isRus
                        "\n  :"
                        "\nThe second point of a rectangular:"
                      ) ;_ end of if
            ) ;_ end of getpoint
  ) ;_ end of setq
  (setq pt1W (trans pt1 1 0)
        pt2W (trans pt2 1 0)
         osm (getvar "OSMODE"))
  (setvar "CMDECHO" 0)
  (setvar "OSMODE" 0)
  (setq ucs (vl-cmdf "_.UCS"
                     "_N"
                     "_3"
                     pt1
                     pt2
                     (polar pt2 (+ (angle pt1 pt2) (* 0.5 PI)) 10)
            ) ;_ end of vl-cmdf
  ) ;_ end of setq
  (setvar "CMDECHO" 1)
  (command "_.RECTANGLE"
           (trans pt1W 0 1)
           ".X"
           (trans pt2W 0 1)
  ) ;_ end of command
  (setvar "OSMODE" osm)
  (command pause)
  (if ucs (command "_.UCS" "_P")) ;_ end of if
  (setvar "UCSFOLLOW" ucf)
(vla-endundomark *kpblc-activedoc*)
  (princ)
) ;_ end of defun
