(defun c:polyline_to_point (/ group-by-num nabor Poly circ type_ poly_coord obj)
  (defun group-by-num (lst num / ls ret)
    (if	(= (rem (length lst) num) 0)
      (progn
	(setq ls nil)
	(repeat	(/ (length lst) num)
	  (repeat num
	    (setq ls
		      (cons (car lst) ls)
		  lst (cdr lst)
	    )
	  )
	  (setq	ret (append ret (list (reverse ls)))
		ls  nil
	  )
	)
      )
    )
    ret
  )
  (setq	nabor
	 (ssget "_:L" '((0 . "LWPOLYLINE,POINT")))
	Poly nil
	circ nil
  	nabor
	 (vl-remove-if-not
	   '(lambda (x) (= (type x) 'ENAME))
	   (mapcar 'cadr (ssnamex nabor))
	 )
  )
  (foreach x nabor
    (setq type_ (cdr (assoc 0 (entget x))))
    (if
      (eq type_ "LWPOLYLINE")
       (setq Poly (cons x Poly))
       (setq circ (cons x circ))
    )
  )
  (setq	circ
	 (mapcar (function
		   (lambda (x)
		     (reverse (cdr (reverse (cdr (assoc 10 (entget x))))))
		   )
		 )
		 circ
	 )
  )
  (foreach x Poly
    (setq poly_coord
	  (mapcar
	    (function
	      (lambda (y)
		(car (vl-sort
		       circ
		       (function (lambda (a b)
				   (< (distance y a) (distance y b))
				 )
		       )
		     )
		)
	      )
	    )
	    (group-by-num
	      (vlax-get
		(setq obj
		       (vlax-ename->vla-object
			 x
		       )
		)
		'Coordinates
	      )
	      2
	    )
	  )
    )
    (vla-put-coordinates
      obj
      (vlax-safearray-fill
	(vlax-make-safearray
	  vlax-vbdouble
	  (cons 0 (1- (* 2 (length poly_coord))))
	)
	(apply 'append poly_coord)
      )
    )



  )
)


















