(defun c:rounded_to (/ znak ss ssleng ss_add obj get_obj point round)
  ;; Joe Burke
  (defun round (value to)
    (if	(zerop to)
      value
      (* (atoi (rtos (/ (float value) to) 2 0)) to)
    )
  )

  (setq
    znak_okrugl	(if znak_okrugl
		  znak_okrugl
		  1.0
		)
    znak	(getreal (strcat "  <"
				 (vl-princ-to-string znak_okrugl)
				 ">:"
			 )
		)
    znak	(if znak
		  znak
		  znak_okrugl
		)
    znak_okrugl	znak
    ss
		(ssget
		  '((0 . "POINT,CIRCLE,LWPOLYLINE"))
		)
    ssleng
		(sslength ss)
    i
		-1
    ss_add
		(ssadd)
  )
  (if ss
    (progn
      (repeat ssleng
	(setq
	  obj	  (ssname ss (setq i (1+ i)))
	  get_obj (entget obj)
	)
	(cond
	  ((WCMATCH (cdr (assoc 0 get_obj))
		    "POINT,CIRCLE"
	   )
	   (setq
	     ss_add  (ssadd obj ss_add)
	     get_obj (mapcar
		       (function
			 (lambda (x)
			   (cond
			     ((eq (car x) 10)
			      (setq point (cdr x))
			      (cons
				10
				(list
				  (round (car point) znak)
				  (round (cadr point) znak)
				  (round (caddr point) znak)
				)
			      )
			     )
			     (t x)
			   )
			 )
		       )
		       get_obj
		     )
	   )
	   (entmod get_obj)
	  )
	  ((eq (cdr (assoc 0 get_obj))
	       "LWPOLYLINE"
	   )
	   (setq
	     ss_add  (ssadd obj ss_add)
	     get_obj (mapcar
		       (function
			 (lambda (x)
			   (cond
			     ((eq (car x) 10)
			      (setq point (cdr x))
			      (cons
				10
				(list
				  (round (car point)
					 znak
				  )
				  (round (cadr point)
					 znak
				  )
				)
			      )
			     )
			     (t x)
			   )
			 )
		       )
		       get_obj
		     )
	   )
	   (entmod get_obj)
	  )
	)
      )
    )
  )
(princ)
  )

(princ)
(if (= (getvar "SysCodePage") "ANSI_1251")
  (princ " : rounded_to")
  (princ "Command name: rounded_to")
)
