(defun c:sspoly (/ adoc ent spline _kpblc-conv-ent-pline-vertex-to-wcs)

  (defun _kpblc-conv-ent-pline-vertex-to-wcs (ent / elevation normal)
                                             ;|
*         (LWPOLYLINE)  WCS. 
*  3-
*    : BOZ (http://www.autocad.ru/cgi-bin/f1/board.cgi?t=26461HC)
*     :
(defun lwpoly_vert (lwpoly / plinee elev vnv)
  (setq	plinee (entget lwpoly)
	elev   (cdr (assoc 38 plinee))
	vnv    (cdr (assoc 210 plinee))
	) ;_ end of setq
  (mapcar
    (function (lambda (x) (trans (list (cadr x) (caddr x) elev) vnv 0)))
    (vl-remove-if-not (function (lambda (x) (= (car x) 10))) plinee)
    ) ;_ end of mapcar
  ) ;_ end of defun
*     :
*	ent	ename-  LWPOLYLINE (  )
*     :
(_kpblc-conv-ent-pline-vertex-to-wcs (car (entsel)))
|;
    (setq elevation (cdr (assoc 38 (entget ent)))
          normal    (cdr (assoc 210 (entget ent)))
          ) ;_ end of setq
    (if (not elevation)
      (setq elevation 0.)
      ) ;_ end of if
    (mapcar '(lambda (x) (trans (list (cadr x) (caddr x) elevation) normal 0))
            (vl-remove-if-not '(lambda (x) (= (car x) 10)) (entget ent))
            ) ;_ end of mapcar
    ) ;_ end of defun

  (vl-load-com)
  (vla-startundomark (setq adoc (vla-get-activedocument (vlax-get-acad-object))))
  (if (= (type (setq selset (vl-catch-all-apply
                              (function
                                (lambda ()
                                  (ssget "_:L" '((0 . "LWPOLYLINE")))
                                  ) ;_ end of lambda
                                ) ;_ end of function
                              ) ;_ end of vl-catch-all-apply
                     ) ;_ end of setq
               ) ;_ end of type
         'pickset
         ) ;_ end of =
    (progn
      (foreach ent ((lambda (/ tab item)
                      (repeat (setq tab  nil
                                    item (sslength selset)
                                    ) ;_ end setq
                        (setq tab (cons (ssname selset (setq item (1- item))) tab))
                        ) ;_ end repeat
                      ) ;_ end of lambda
                    )
        (setq spline (vla-addspline
                       (vla-objectidtoobject adoc (vla-get-ownerid (vlax-ename->vla-object ent)))
                       ((lambda (/ lst)
                          (setq lst (apply 'append (_kpblc-conv-ent-pline-vertex-to-wcs ent)))
                          (vlax-make-variant (vlax-safearray-fill (vlax-make-safearray vlax-vbdouble
                                                                                       (cons 0 (1- (length lst)))
                                                                                       ) ;_ end of vlax-make-safearray
                                                                  lst
                                                                  ) ;_ end of vlax-safearray-fill
                                             ) ;_ end of vlax-make-variant
                          ) ;_ end of lambda
                        )
                       (vlax-3d-point '(0. 0. 0.))
                       (vlax-3d-point '(0. 0. 0.))
                       ) ;_ end of vla-addspline
              ent    (vlax-ename->vla-object ent)
              ) ;_ end of setq
        (foreach prop '("layer" "color" "lineweight" "linetype" "closed")
          (vl-catch-all-apply
            (function
              (lambda ()
                (vlax-put-property spline prop (vlax-get-property ent prop))
                ) ;_ end of lambda
              ) ;_ end of function
            ) ;_ end of vl-catch-all-apply
          ) ;_ end of foreach
      (vla-erase ent) ;    ,  
        ) ;_ end of foreach
      ) ;_ end of progn
    ) ;_ end of if
  (vla-endundomark adoc)
  (princ)
  ) ;_ end of defun