(defun c:summator (/
		   get-tmp-file
		   assoc-value
		   select-objects
		   list-to-string
		   ent-sel-no-empty
		   _rusp
		   mip_MTEXT_Unformat
		   dim-get-text-string
		   str->list
		   get-number-for-summator
		   dialog-summator-fun
		   pre-dialog-fun
		   adoc
		   sum_obj
		   sum_del
		   sum_scl
		   sum_prc
		   sum_dia_pos
		   sum_dia_pos1
		   din
		   ddn
		   dfn
		   obj_lst
		   del
		   err_msg
		   rez
		  )

  ;;      : (VL-REGISTRY-DELETE "HKEY_CURRENT_USER\\Software\\Do$\\Lsp_for_acad\\summator\\")
  ;;       : (VL-REGISTRY-DELETE "HKEY_CURRENT_USER\\Software\\Do$")


  (vl-load-com)

  (defun get-tmp-file (lst / fo fn)
		      ;|
          .
:
	lst -   ,     
	      (      "  ")
 :
	,            .
 :
((lambda (/ file-name)
   (startapp "Notepad.exe"
	     (setq
	       file-name
		(get-tmp-file
		  (list	"     :"
			"-    "
			"-    "
			"- !    ..."
		  ) ;_ end of list
		) ;_ end of get-tmp-file
	     ) ;_ end of setq
   ) ;_ end of startapp
   (vl-file-delete (findfile file-name))
 ) ;_ end of lambda
)
  |;
    (setq fn (vl-filename-mktemp nil nil ".tmp")
	  fo (open fn "w")
    ) ;_ end of setq
    (foreach
	      str
		 lst
      (write-line
	(vl-princ-to-string str)
	fo
      ) ;_ end of write-line
    ) ;_ end of foreach
    (close fo)
    fn
  ) ;_ end of defun

  (defun assoc-value (cd ent)
    (cdr (assoc cd (entget ent)))
  ) ;_ end of defun

  (defun select-objects	(msg
			 types_lst
			 /
			 check-first-set
			 ss-get-to-lst
			 ss-to-lst
			 ss-get
			 ent_lst
			)
    ;;(select-objects " :" '("TEXT"))
    ;;(apply (function select-objects)  '(" :" ("*LINE" "ARC" "ELLIPSE")))

    (defun check-first-set (types_lst / ssf ent_lst)
      ;;(check-first-set '("LINE"))
      (if
	(and (setq ssf (ssget "_I"))
	     (vl-every
	       (function (lambda (ent / typ)
			   (setq typ (assoc-value 0 ent))
			   (vl-member-if
			     (function (lambda (a) (wcmatch typ a)))
			     types_lst
			   ) ;_ end of vl-member-if
			 ) ;_ end of lambda
	       ) ;_ end of function
	       (setq ent_lst (ss-to-lst ssf))
	     ) ;_ end of vl-every
	) ;_ end of and
	 ent_lst
      ) ;_ end of if 
    ) ;_ end of defun

    (defun ss-get-to-lst (rep lst / ss)
      ;;  : (ss-get-to-lst " :" (list '((0 . "TEXT"))))
      ;;  -: ss-get, ss-to-lst
      ;;   ename   nil  T
      (setq ss (ss-get rep lst))
      (if (= (type ss) (quote pickset))
	(ss-to-lst ss)
	ss
      ) ;_ end of if
    ) ;_ end of defun

    (defun ss-to-lst (ss / i ent lst)
      ;;   ename- 
      ;;(ss-to-lst (ssget))
      (setq i 0)
      (while (setq ent (ssname ss i))
	(setq lst (cons ent lst)
	      i	  (1+ i)
	) ;_ end of setq
      ) ;_ end of while
      (reverse lst)
    ) ;_ end of defun

    (defun ss-get (rep lst / ss)
      ;;(ss-get " :" (list '((0 . "LINE"))))
      (prompt rep)
      (setq
	ss (vl-catch-all-apply
	     (function ssget)
	     lst
	   ) ;_ end of vl-catch-all-apply
      ) ;_ end of setq
      (cond
	((vl-catch-all-error-p ss) nil)
	((not ss) T)
	(T ss)
      ) ;_ end of cond
    ) ;_ end of defun

    (cond
      ((check-first-set types_lst))
      ((progn
	 (sssetfirst nil nil)
	 (ss-get-to-lst
	   msg
	   (list
	     (append
	       (quote ((-4 . "<OR")))
	       (mapcar (function (lambda (typ) (cons 0 typ))) types_lst)
	       (quote ((-4 . "OR>")))
	     ) ;_ end of append
	   ) ;_ end of list
	 ) ;_ end of ss-get-to-lst
       ) ;_ end of progn
      )
    ) ;_ end of cond
  ) ;_ end of defun

  (defun list-to-string	(lst del)
    ;;(list-to-string '("test1a" "test2a" "test3a") "_ab_")
    (apply
      (function strcat)
      (cons
	(car lst)
	(mapcar	(function (lambda (a) (strcat del a)))
		(cdr lst)
	) ;_ end of mapcar
      ) ;_ end of cons
    ) ;_ end of apply
  ) ;_ end of defun

  (defun ent-sel-no-empty (msg / ent-sel sel)
    ;;(ent-sel-no-empty "\n :")
    ;;:
    ;;  nil -     Esc
    ;;  T -     Enter
    ;;  (<ename> <point>) -   

    (defun ent-sel (msg / sel)

      ;;  .
      ;;: msg - ,      .
      ;; :
      ;; -   (nil <>),           
      ;; - T,       Enter
      ;; - NIL,       Esc
      ;; -   (<ename> <>)  -  (    initget)
      ;; :
      ;;(progn (initget " _Test")(ent-sel "\n :[]"))

      (cond
	((not
	   (setq sel (vl-catch-all-apply
		       (function (lambda () (entsel msg)))
		     ) ;_ end of vl-catch-all-apply
	   ) ;_ end of setq
	 ) ;_ end of not
	 (cond
	   ((= (getvar "errno") 7)
	    (list nil (cadr (grread T 9)))
	   )
	   ((= (getvar "errno") 52) T)
	 ) ;_ end of cond
	)
	((vl-catch-all-error-p sel) nil)
	(T sel)
      ) ;_ end of cond
    ) ;_ end of defun

    (while (and	(setq sel (ent-sel msg))
		(listp sel)
		(not (car sel))
	   ) ;_ end of and
      (prompt (if (_rusp)
		"   !"
		" Nothing selected!"
	      ) ;_ end of if
      ) ;_ end of prompt
    ) ;_ end of while
    sel
  ) ;_ end of defun

  (defun _rusp () (= (getvar "syscodepage") "ANSI_1251"))

  (defun mip_MTEXT_Unformat (Mtext / text Str)
    (setq Text "")
    (while (/= Mtext "")
      (cond
	((wcmatch (strcase (setq Str (substr Mtext 1 2))) "\\[\\{}]")
	 (setq Mtext (substr Mtext 3)
	       Text  (strcat Text Str)
	 ) ;_ end of setq
	)
	((wcmatch (substr Mtext 1 1) "[{}]")
	 (setq Mtext (substr Mtext 2))
	)
	((wcmatch (strcase (setq Str (substr Mtext 1 2))) "\\[LO`~]")
	 (setq Mtext (substr Mtext 3))
	)
	((wcmatch (strcase (substr Mtext 1 2)) "\\[ACFHQTW]")
	 (setq Mtext (substr Mtext (+ 2 (vl-string-search ";" Mtext))))
	)
	((wcmatch (strcase (substr Mtext 1 2)) "\\P")
	 (if (or (= " " (substr Text (strlen Text)))
		 (= " " (substr Mtext 3 1))
	     ) ;_ end of or
	   (setq Mtext (substr Mtext 3))
	   (setq Mtext (substr Mtext 3)
		 Text  (strcat Text " ")
	   ) ;_ end of setq
	 ) ;_ end of if
	)
	((wcmatch (strcase (substr Mtext 1 2)) "\\S")
	 (setq Str   (substr Mtext 3 (- (vl-string-search ";" Mtext) 2))
	       Text  (strcat Text (vl-string-translate "#^\\" "/^\\" Str))
	       Mtext (substr Mtext (+ 4 (strlen Str)))
	 ) ;_ end of setq
	)
	(t
	 (setq Text  (strcat Text (substr Mtext 1 1))
	       Mtext (substr Mtext 2)
	 ) ;_ end of setq
	)
      ) ;_ end of cond
    ) ;_ end of while
    Text
  ) ;_ end of defun


  (defun dim-get-text-string (dim / str)
    ;;(dim-get-text-string (car (entsel "\nSelect dimension:")))
    (vlax-for item
	      (vla-item	(vla-get-blocks
			  (vla-get-activedocument (vlax-get-acad-object))
			) ;_ end of vla-get-Blocks
			(cdr (assoc 2 (entget dim)))
	      ) ;_ end of vla-item
      (if (vlax-property-available-p item 'Textstring)
	(setq str (vla-get-textstring item))
      ) ;_ end of if
    ) ;_ end of vlax-for
    (mip_MTEXT_Unformat str)
  ) ;_ end of defun

  (defun str->list (s)
		   ;|
***************************************************************************************
*
*         .
*   ,      .
* 
**************************************************************************************
*
*          (ElpanovEvgeniy)
*
*   (13/10/2007 a 11:42)
*      :
* http://www.cadxp.com/XForum+viewthread-fid-101-tid-16943-page-2.html
***************************************************************************************
*     :
* (str->list "point.25.4cm.")           => ("point." 25.4 "cm.")
* (str->list "point.25,4cm.")           => ("point." 25.4 "cm.")
* (str->list "point.3/8cm.")            => ("point." 0.375 "cm.")
* (str->list "qvf12qsdf125 5sf 56dfv2") => ("qvf" 12 "qsdf" 125 " " 5 "sf " 56 "dfv" 2)
***************************************************************************************
 |;
    (defun str->list1 (a b f)
      (cond
	((null b)
	 (list
	   (if f
	     (cond ((vl-position 46 a)
		    (atof (vl-list->string (reverse a)))
		   )
		   ((vl-position 47 a)
		    (distof (vl-list->string (reverse a)))
		   )
		   ((vl-position 44 a)
		    (atof (vl-list->string (subst 46 44 (reverse a))))
		   )
		   (t (atoi (vl-list->string (reverse a))))
	     ) ;_ end of cond
	     (vl-list->string (reverse a))
	   ) ;_ end of if
	 ) ;_ end of list
	)
	(f
	 (if (or (= (car b) 44) (< 45 (car b) 58))
	   (str->list1 (cons (car b) a) (cdr b) f)
	   (cons
	     (cond ((vl-position 46 a)
		    (atof (vl-list->string (reverse a)))
		   )
		   ((vl-position 47 a)
		    (distof (vl-list->string (reverse a)))
		   )
		   ((vl-position 44 a)
		    (atof (vl-list->string (subst 46 44 (reverse a))))
		   )
		   (t (atoi (vl-list->string (reverse a))))
	     ) ;_ end of cond
	     (str->list1 (list (car b)) (cdr b) nil)
	   ) ;_ end of cons
	 ) ;_ end of if
	)
	(t
	 (if (< 47 (car b) 58)
	   (cons (vl-list->string (reverse a))
		 (str->list1 (list (car b)) (cdr b) t)
	   ) ;_ end of cons
	   (str->list1 (cons (car b) a) (cdr b) nil)
	 ) ;_ end of if
	)
      ) ;_ end of cond
    ) ;_ end of defun
    (setq s (vl-string->list s))
    (str->list1
      (list (car s))
      (cdr s)
      (if (or (= (car s) 44) (< 45 (car s) 58))
	t
      ) ;_ end of if
    ) ;_ end of str->list1
  ) ;_ end of defun

;;;Setttings

  (setq	dfn	    (get-tmp-file
		      (if (_rusp)
			(list
			  "summator"
			  ":dialog{label=\" \";\t"
			  "\t:popup_list {label=\":\"; key=\"obj\"; list=\" \\n\\n \";}"
			  "\t:row{"
			  "\t\t:button {label=\" \"; key=\"sel\"; width=5; height=1; fixed_width=true; is_default=true; initial_focus=true;}"
			  "\t\t:button {label=\"\"; key=\"set\"; height=1; fixed_width=true;}}"
			  "\t:column{label=\"\";"
			  "\t\t:edit_box {key=\"rez\"; height=1;}"
			  "\t\t:errtile {}"
			  "\t\t:button {label=\"   \"; key=\"ins\"; height=1; fixed_width=true; is_enabled=false;}}"
			  "\t:row{"
			  "\t\t:button {label=\"\"; key=\"hst\"; height=1; fixed_width=true;}"
			  "\t\t:cancel_button {label=\"\";}\t\t"
			  "\t\t:info_button {label=\"\"; is_enabled=false;}}\t"
			  "}//end of dialog"
			  ""
			  "histori"
			  ":dialog{label=\"                                                                          \";"
			  ":list_box {key=\"exp\"; height=15;}"
			  "ok_button;"
			  "}//end of dialog"
			  ""
			  "settings"
			  ":dialog{label=\"\";"
			  ":radio_column {key=\"del\"; label=\"\";"
			  "\t:radio_button {label=\". ()\"; key=\".\";}"
			  "\t:radio_button {label=\", ()\"; key=\",\";}}\t"
			  ":edit_box {label=\":\"; key=\"scl\"; width=6; height=1; fixed_width=true;}"
			  ":popup_list {label=\":\"; key=\"prc\"; list=\"0\\n0.0\\n0.00\\n0.000\\n0.0000\\n0.00000\\n0.000000\\n0.0000000\\n0.00000000\";}"
			  ":row{"
			  "\t:ok_button {label=\"\";}"
			  "\t:cancel_button {label=\"\";}}"
			  ":button {label=\"\"; key=\"more\";}"
			  "}//end of dialog"
			  ""
			  ""
			  "more"
			  ":dialog {label=\"\";"
			  ":column {label=\" :\";"
			  "\t:radio_row {label=\" \"; key=\"dim_val\";"
			  "\t\t\t:radio_button {label=\" \"; key=\"real\";}"
			  "\t\t\t:radio_button {label=\" \"; key=\"disp\";}}}"
			  "ok_button;}"
			) ;_ end of list
			(list
			  "summator"
			  ":dialog{label=\"Summator for acad\";\t"
			  "\t:popup_list {label=\"Objects:\"; key=\"obj\"; list=\"Texts\\nDimensions\\nLines length\";}"
			  "\t:row{"
			  "\t\t:button {label=\"Select objects\"; key=\"sel\"; width=5; height=1; fixed_width=true; is_default=true; initial_focus=true;}"
			  "\t\t:button {label=\"Settings\"; key=\"set\"; height=1; fixed_width=true;}"
			  "\t}"
			  "\t:column{label=\"Result\";"
			  "\t\t:edit_box {key=\"rez\"; height=1;}"
			  "\t\t:errtile {}"
			  "\t\t:button {label=\"Insert rezult in text\"; key=\"ins\"; height=1; fixed_width=true; is_enabled=false;}\t\t"
			  "\t}"
			  "\t:row{"
			  "\t\t:button {label=\"History\"; key=\"hst\"; height=1; fixed_width=true;}"
			  "\t\t:cancel_button {label=\"Exit\";}\t\t"
			  "\t\t:info_button {label=\"Info\"; is_enabled=false;}}\t"
			  "}//end of dialog"
			  ""
			  "histori"
			  ":dialog{label=\"History                                                                               \";"
			  ":list_box {key=\"exp\"; height=15;}"
			  "ok_button;"
			  "}//end of dialog"
			  ""
			  "settings"
			  ":dialog{label=\"Settings\";"
			  ":radio_column {key=\"del\"; label=\"Delimeter\";"
			  "\t:radio_button {label=\". (Point)\"; key=\".\";}"
			  "\t:radio_button {label=\", (Comma)\"; key=\",\";}}\t"
			  ":edit_box {label=\"Multiplier:\"; key=\"scl\"; width=6; height=1; fixed_width=true;}"
			  ":popup_list {label=\"Precision:\"; key=\"prc\"; list=\"0\\n0.0\\n0.00\\n0.000\\n0.0000\\n0.00000\\n0.000000\\n0.0000000\\n0.00000000\";}"
			  ":row{"
			  "\t:ok_button {label=\"  Save  \";}"
			  "\t:cancel_button {label=\"Cancel\";}}"
			  ":button {label=\"More\"; key=\"more\";}"
			  "}//end of dialog"
			  ""
			  ""
			  "more"
			  ":dialog {label=\"More\";"
			  ":column {label=\"For dimensions:\";"
			  "\t:radio_row {label=\"Summable value:\"; key=\"dim_val\";"
			  "\t\t\t:radio_button {label=\"Real value\"; key=\"real\";}"
			  "\t\t\t:radio_button {label=\"Display value\"; key=\"disp\";}}}"
			  "ok_button;}"
			) ;_ end of list
		      ) ;_ end of if
		    ) ;_ end of get-tmp-file
	obj_lst	    (if	(_rusp)
		      (quote (("" " :" ("TEXT" "MTEXT"))
			       (" "
				 " :"
				 ("*LINE" "ARC" "ELLIPSE")
			       )
			       ("" " :" ("DIMENSION"))
			     )
		      ) ;_ end of quote
		      (quote
			(("Text contents" "Select texts:" ("TEXT" "MTEXT"))
			  ("Lines length"
			    "Select lines:"
			    ("*LINE" "ARC" "ELLIPSE")
			  )
			  ("Dimensions" "Select dimensions:" ("DIMENSION"))
			)
		      ) ;_ end of quote
		    ) ;_ end of if
	sum_obj	    (cond
		      ((vl-registry-read
			 "HKEY_CURRENT_USER\\Software\\Do$\\Lsp_for_acad\\summator\\"
			 "sum_obj"
		       ) ;_ end of vl-registry-read
		      )
		      (T
		       (vl-registry-write
			 "HKEY_CURRENT_USER\\Software\\Do$\\Lsp_for_acad\\summator\\"
			 "sum_obj"
			 "0"
		       ) ;_ end of vl-registry-write
		      )
		    ) ;_ end of cond
	sum_del	    (cond
		      ((vl-registry-read
			 "HKEY_CURRENT_USER\\Software\\Do$\\Lsp_for_acad\\summator\\"
			 "sum_del"
		       ) ;_ end of vl-registry-read
		      )
		      (T
		       (vl-registry-write
			 "HKEY_CURRENT_USER\\Software\\Do$\\Lsp_for_acad\\summator\\"
			 "sum_del"
			 "."
		       ) ;_ end of vl-registry-write
		      )
		    ) ;_ end of cond
	sum_scl	    (read
		      (cond
			((vl-registry-read
			   "HKEY_CURRENT_USER\\Software\\Do$\\Lsp_for_acad\\summator\\"
			   "sum_scl"
			 ) ;_ end of vl-registry-read
			)
			(T
			 (vl-registry-write
			   "HKEY_CURRENT_USER\\Software\\Do$\\Lsp_for_acad\\summator\\"
			   "sum_scl"
			   "1.0"
			 ) ;_ end of vl-registry-write
			)
		      ) ;_ end of cond
		    ) ;_ end of read
	sum_prc	    (atoi
		      (cond
			((vl-registry-read
			   "HKEY_CURRENT_USER\\Software\\Do$\\Lsp_for_acad\\summator\\"
			   "sum_prc"
			 ) ;_ end of vl-registry-read
			)
			(T
			 (vl-registry-write
			   "HKEY_CURRENT_USER\\Software\\Do$\\Lsp_for_acad\\summator\\"
			   "sum_prc"
			   (itoa (getvar "luprec"))
			 ) ;_ end of vl-registry-write
			)
		      ) ;_ end of cond
		    ) ;_ end of atoi
	sum_dia_pos (read
		      (cond
			((vl-registry-read
			   "HKEY_CURRENT_USER\\Software\\Do$\\Lsp_for_acad\\summator\\"
			   "sum_dia_pos"
			 ) ;_ end of vl-registry-read
			)
			(T
			 (vl-registry-write
			   "HKEY_CURRENT_USER\\Software\\Do$\\Lsp_for_acad\\summator\\"
			   "sum_dia_pos"
			   (vl-princ-to-string '(-1 -1))
			 ) ;_ end of vl-registry-write
			)
		      ) ;_ end of cond
		    ) ;_ end of read
	sum_dim_val (cond
		      ((vl-registry-read
			 "HKEY_CURRENT_USER\\Software\\Do$\\Lsp_for_acad\\summator\\"
			 "sum_dim_val"
		       ) ;_ end of vl-registry-read
		      )
		      (T
		       (vl-registry-write
			 "HKEY_CURRENT_USER\\Software\\Do$\\Lsp_for_acad\\summator\\"
			 "sum_dim_val"
			 "real"
		       ) ;_ end of vl-registry-write
		      )
		    ) ;_ end of cond
  ) ;_ end of setq


;;;Support functions

  (defun get-number-for-summator (ent / typ str val)
    ;;(get-number-for-summator (car (entsel)))
    (cond
      ((and
	 (wcmatch (setq typ (assoc-value 0 ent)) "TEXT,MTEXT")
	 (not
	   (and	(wcmatch (setq str (assoc-value 1 ent)) "*`.*")
		(/= sum_del ".")
	   ) ;_ end of and
	 ) ;_ end of not
	 (numberp
	   (setq
	     val (distof
		   (vl-string-subst "." sum_del str)
		 ) ;_ end of atof
	   ) ;_ end of setq
	 ) ;_ end of numberp
       ) ;_ end of and
       val
      )
      ((= typ "DIMENSION")
       (if (= sum_dim_val "real")
	 (assoc-value 42 ent)
	 (progn
	   (car	(vl-member-if
		  (function numberp)
		  (str->list (dim-get-text-string ent))
		) ;_ end of vl-member-if
	   ) ;_ end of car
	 ) ;_ end of progn
       ) ;_ end of if
      )
      ((= typ "LINE")
       (distance (assoc-value 10 ent)
		 (assoc-value 11 ent)
       ) ;_ end of distance
      )
      ((wcmatch typ "*LINE,ARC,ELLIPSE")
       (vlax-curve-getDistAtPoint ent (vlax-curve-getEndPoint ent))
      )
    ) ;_ end of cond
  ) ;_ end of defun

  (defun dialog-summator-fun (key value reason data x y)
    (setq
      sum_dia_pos
       (cond
	 ((= key "sel")
	  (setq rez nil)
	  (done_dialog 1)
	 )
	 ((= key "cancel") (done_dialog 0))
	 ((= key "ins") (setq rez (get_tile "rez")) (done_dialog 3))
	 ((= key "obj")
	  (setq	val_lst	nil
		rez nil
		sum_obj	value
	  ) ;_ end of setq
	  (done_dialog 2)
	 )
	 ((= key "set") (done_dialog 4))
	 ((= key "hst")
	  (new_dialog
	    "histori"
	    din ;|"(if (= $key \"accept\") (done_dialog 1))"|;
	  ) ;_ end of new_dialog
	  (start_list "exp")
	  (mapcar (function add_list) *sum-hist-lst*)
	  (end_list)
	  (start_dialog)
	 )
       ) ;_ end of cond
    ) ;_ end of setq
  ) ;_ end of defun

  (defun pre-dialog-fun	()
    (start_list "obj")
    (mapcar (function add_list) (mapcar (function car) obj_lst))
    (end_list)
    (set_tile "error"
	      (cond (err_msg)
		    (T "")
	      ) ;_ end of cond
    ) ;_ end of set_tile
    (set_tile "obj" sum_obj)
    (if	rez
      (progn
	;;(setq *sum-hist-lst* nil)
	(set_tile "rez" rez)
	(if (equal ddn T)
	  (mode_tile "sel" 2)
	  (progn (mode_tile "ins" 0)
		 (mode_tile "ins" 2)
	  ) ;_ end of progn
	) ;_ end of if
      ) ;_ end of progn
      (progn
	(mode_tile "ins" 1)
	(set_tile "rez" "")
      ) ;_ end of progn
    ) ;_ end of if
  ) ;_ end of defun


;;;Body

  (if (> (setq din (load_dialog dfn)) 0)
    (progn
      (while (not (member ddn (list 0)))
	(if (new_dialog
	      "summator"
	      din
	      "(dialog-summator-fun $key $value $reason $data $X $Y)"
	      sum_dia_pos
	    ) ;_ end of new_dialog
	  (progn
	    (pre-dialog-fun)
	    (setq ddn (start_dialog))
	  ) ;_ end of progn
	) ;_ end of if
	(cond
	  ((= ddn 1)
	   ((lambda (/ ent_lst val_lst)
	      (setq ddn	    nil
		    ent_lst (apply (function select-objects)
				   (cdr (nth (atoi sum_obj) obj_lst))
			    ) ;_ end of apply
	      ) ;_ end of setq
	      (setq err_msg
		     (cond
		       ((not (and ent_lst (listp ent_lst)))
			(if (_rusp)
			  "  !"
			  "Nothing select!"
			) ;_ end of if
		       )
		       ((member	nil
				(setq val_lst
				       (mapcar (function get-number-for-summator)
					       ent_lst
				       ) ;_ end of mapcar
				) ;_ end of setq
			) ;_ end of member
			(if (_rusp)
			  "   !"
			  "Invalid characters in text!"
			) ;_ end of if
		       )
		       (T
			(setq
			  rez		 (vl-string-subst
					   sum_del
					   "."
					   (rtos
					     (*	sum_scl
						(apply (function +) val_lst)
					     ) ;_ end of *
					     2
					     sum_prc
					   ) ;_ end of rtos
					 ) ;_ end of vl-string-subst
			  *sum-hist-lst* (cons
					   (strcat
					     "("
					     (list-to-string
					       (mapcar
						 (function
						   (lambda (val)
						     (vl-string-subst
						       sum_del
						       "."
						       (rtos val
							     2
							     sum_prc
						       ) ;_ end of rtos
						     ) ;_ end of vl-string-subst
						   ) ;_ end of lambda
						 ) ;_ end of function
						 val_lst
					       ) ;_ end of mapcar
					       "+"
					     ) ;_ end of list-to-string
					     ")*"
					     (vl-string-subst
					       sum_del
					       "."
					       (vl-princ-to-string
						 sum_scl
					       ) ;_ end of vl-princ-to-string
					     ) ;_ end of vl-string-subst
					     "="
					     rez
					   ) ;_ end of strcat
					   *sum-hist-lst*
					 ) ;_ end of cons
			) ;_ end of setq
			nil
		       )
		     ) ;_ end of cond
	      ) ;_ end of setq
	    ) ;_ end of lambda
	   )
	  )
	  ((= ddn 3)
	   (setq ddn T)
	   ((lambda (/ txt)
	      (while
		(and (setq
		       txt (ent-sel-no-empty
			     (if (_rusp)
			       "\n    :"
			       "\nSelect text:"
			     ) ;_ end of if
			   ) ;_ end of ent-sel-no-empty
		     ) ;_ end of setq
		     (listp txt)
		) ;_ end of and
		 (if
		   (wcmatch (assoc-value 0 (car txt)) "TEXT,MTEXT")
		    (progn
		      (vla-StartUndoMark
			(setq adoc (vla-get-ActiveDocument
				     (vlax-get-acad-object)
				   ) ;_ end of vla-get-ActiveDocument
			) ;_ end of setq
		      ) ;_ end of vla-StartUndoMark
		      (entmod (list (cons -1 (car txt)) (cons 1 rez)))
		      (vla-EndUndoMark adoc)
		    ) ;_ end of progn
		    (prompt (if	(_rusp)
			      "    !"
			      " Not text! Select text or mtext!"
			    ) ;_ end of if
		    ) ;_ end of prompt
		 ) ;_ end of if
	      ) ;_ end of while
	    ) ;_ end of lambda
	   )
	  )

	  ((= ddn 4)
	   (setq ddn nil
		 rez nil
	   ) ;_ end of setq
	   ((lambda (/ dialog-summator-fun1 ddn)

	      (defun dialog-summator-fun1 (key value reason data x y)
		(cond
		  ((= key "accept")
		   (setq sum_del (get_tile "del"))
		   (setq sum_scl (atof (get_tile "scl")))
		   (setq sum_prc (atoi (get_tile "prc")))
		   (setq sum_dia_pos1 (done_dialog 1))
		  )
		  ((= key "more")
		   (new_dialog
		     "more"
		     din
		     ""
		     (cond
		       (sum_dia_pos1)
		       (sum_dia_pos)
		     ) ;_ end of cond
		   ) ;_ end of new_dialog
		   (set_tile "dim_val" sum_dim_val)
		   (action_tile "dim_val" "(setq sum_dim_val $value)")
		   (start_dialog)
		  )
		) ;_ end of cond		
	      ) ;_ end of defun
	      (while (not (member ddn (list 0 1)))
		(if
		  (new_dialog
		    "settings"
		    din
		    "(dialog-summator-fun1 $key $value $reason $data $X $Y)"
		    (cond
		      (sum_dia_pos1)
		      (sum_dia_pos)
		    ) ;_ end of cond
		  ) ;_ end of new_dialog
		   (progn
		     (set_tile "del" sum_del)
		     (set_tile "scl" (rtos sum_scl 2 sum_prc))
		     (set_tile "prc" (itoa sum_prc))
		     (setq ddn (start_dialog))
		   ) ;_ end of progn
		) ;_ end of if
	      ) ;_ end of while
	    ) ;_ end of lambda
	   )
	  )
	) ;_ end of cond
      ) ;_ end of while
      (unload_dialog din)
    ) ;_ end of progn
  ) ;_ end of if
  (vl-file-delete dfn)
  (vl-registry-write
    "HKEY_CURRENT_USER\\Software\\Do$\\Lsp_for_acad\\summator\\"
    "sum_obj"
    sum_obj
  ) ;_ end of vl-registry-write
  (vl-registry-write
    "HKEY_CURRENT_USER\\Software\\Do$\\Lsp_for_acad\\summator\\"
    "sum_del"
    sum_del
  ) ;_ end of vl-registry-write
  (vl-registry-write
    "HKEY_CURRENT_USER\\Software\\Do$\\Lsp_for_acad\\summator\\"
    "sum_scl"
    (vl-princ-to-string sum_scl)
  ) ;_ end of vl-registry-write
  (vl-registry-write
    "HKEY_CURRENT_USER\\Software\\Do$\\Lsp_for_acad\\summator\\"
    "sum_prc"
    (itoa sum_prc)
  ) ;_ end of vl-registry-write
  (vl-registry-write
    "HKEY_CURRENT_USER\\Software\\Do$\\Lsp_for_acad\\summator\\"
    "sum_dia_pos"
    (vl-princ-to-string sum_dia_pos)
  ) ;_ end of vl-registry-write
  (vl-registry-write
    "HKEY_CURRENT_USER\\Software\\Do$\\Lsp_for_acad\\summator\\"
    "sum_dim_val"
    sum_dim_val
  ) ;_ end of vl-registry-write
  (princ)
) ;_ end of defun