(defun c:uklon (/ a a1 a2 ang b b1 b2 mp osm pt1 pt2 th txthgt ukl) 
  (setq osm (getvar "osmode")) 
  (setvar "osmode" 33) 
  (setq th (getvar "dimtxt")) 
  (setq txthgt (getreal (strcat "\nText height <" (rtos th 2 2) " >: "))) 
  (if (not txthgt)(setq txthgt th)) 
  (setq pt1 (getpoint "\nSpecify a first point ( or Press Enter to Exit): ")) 
  (while   
  (setq pt2 (getpoint pt1 "\nSpecify next point : ")) 
   
  (setq ang (angle pt1 pt2)) 
  ;; math to get angle more readable 
  (setq ang(cond ((< (/ pi 2) ang (* pi 1.5)) 
        (+ pi ang)) 
               (T ang)) 
         ) 
  ;; get middle point 
  (setq mp (mapcar '(lambda (a b)(/( + a b) 2)) pt1 pt2)) 
  (setq a1 (car pt1)) 
  (setq b1 (cadr pt1)) 
  (setq a2 (car pt2)) 
  (setq b2 (cadr pt2)) 

  (setq ukl (* (/ (- b2 b1) (- a1 a2)) 100)) 
  (if (< ukl 0) 
    (setq ukl (* ukl -1)) 
  ) 
(entmake 
  (list 
    '(0 . "TEXT") 
    '(100 . "AcDbEntity") 
    '(67 . 0) 
    '(410 . "Model") 
    '(8 . "DIM") 
    '(100 . "AcDbText") 
    (cons 10 mp) 
    (cons 11 (list (car mp) (+ (cadr mp) txthgt) 0.0)) 
    (cons 40 txthgt) 
    (cons 1 (strcat (rtos ukl 2 3)"%")) 
    (cons 50 ang) 
    '(41 . 1.0) 
    '(51 . 0.0) 
    '(7 . "Standard") 
    '(71 . 0) 
    '(72 . 0) 
    (cons 210 (list 0.0 0.0 1.0)) 
    '(73 . 2))) 
  (setq pt1 pt2) 
) 
(setvar "osmode" osm)    
  (princ) 

)