(defun c:wpromi (/ pt1 pt2 h1 h2)
	(setq pt1 (getpoint "\nSelect first point\n"))
	(setq h1 (gnum2 "\nSelect first height\n"))
	(setq pt2 (getpoint "\nSelect second point\n"))
	(setq h2 (gnum2 "\nSelect first height\n"))
	(* (/ (- h1 h2) (distance pt1 pt2)) 1000.0)
)


;(mkroadpts p1 p2 h1 h2 st should *promi-across*)
(defun mkroadpts (pt1 pt2 h1 h2 st should pr / tmp an rat p3 p4 p5 olst n)
	(if (< h1 h2)
		(setq
			tmp h1 h1 h2 h2 tmp
			tmp p1 p1 p2 p2 tmp
		))
	(setq
		an (angle p1 p2)
		rat (/ (distance p1 p2) (- h1 h2))
		p3 (polar p1 an (* (- h1 (rndby h1 st)) rat))
		stpl (* st rat)
		p4 (polar (polar p3 (- an pi ) (/ (* should stpl pr) st 1000) ) (+ an (/ pi 2)) should)
		p5 (polar p4 (- an (/ pi 2)) (* 2 should))
		olst (list (list p4 p3 p5))
		)
	
	(repeat
		(if (not (= 0 (setq n (atoi (rtos (/ (- h1 h2) 0.1) 2 0))))) n 1)
			(setq olst (cons (mapcar '(lambda (x) (polar x an stpl)) (car olst)) olst)))
)