(defun c:contour_label (/ _text _ang offset height	to count ss ent	chainage ln _mp
	     bearing p p2 point1)
  (vl-load-com)
  (defun _text (p b o h c)
;;;  modified by pbe to add background mask
    (entmake
      (append
	'((0 . "MTEXT")
	  (100 . "AcDbEntity")
	  (67 . 0)
	  (410 . "Model")
	  (8 . " ")
	  (100 . "AcDbMText")
	 )
	(list (cons 10 (polar p (+ b PI) o))
	)
	(list (cons 40 h))
	(list
	  (cons
	    1
	    (strcat ""
		    (if	(setq ld (nth (strlen (rtos c 2 0)) '(x "")))
		      ld
		      ""
		    )
		    (rtos c 2 2)
	    )
	  )
	)
	(list (cons 50 (+ b (/ pi 2))))

	(list '(41 . 0)
	      '(90 . 3)			;<-- Mask
	      '(63 . 256)		;<--Mask
	      '(441 . 3935927)		;<-- Mask 
	      '(71 . 5)
	      '(72 . 5)
	      (cons 7 (getvar "textstyle"))
	      '(210 0.0 0.0 1.0)
	      '(73 . 3)
	)
      )
    )
  )
;;;		Modified by pBe		;;;
  (defun _ang (en d pt)
    (+ (angle '(0.0 0.0 0.0)
	      (vlax-curve-getfirstderiv
		en
		(vlax-curve-getparamatpoint en pt)
	      )
       )
       (* pi 1.5)
    )
  )

;;;		Modified by pBe		;;;

  (setq	dist (cond ((getdist "    <25>:"))
		   (25)
	     )
  )
  (setq offset 0)
  (setq height 1)
  (setq to 0)
  (setq	ss    (ssget)
	count 0
  )
  (repeat (sslength ss)
    (setq ent	   (ssname ss count)
	  obj	   (vlax-ename->vla-object ent)
	  chainage dist
    )
    (setq p (vlax-curve-getstartpoint ent))
    (setq p2 (vlax-curve-getendpoint ent))

;;;	Additional option / re-arrange sequence		;;;

;;;;modified by mircea to get the elevation value of polyline    
    (_text p (_ang ent chainage p) to height (caddr p))

;;; 	Start/Mid/End mode iI Length is less than or equal twice the value of dist variable	;;;
    (if	(<= (setq ln (vlax-curve-getdistatparam
		       ent
		       (vlax-curve-getendparam ent)
		     )
	    )
	    (* 2 dist)
	)
      (_text (setq _mp (vlax-curve-getpointatdist ent (* ln 0.5)))
	     (_ang ent (* ln 0.5) _mp)
	     to
	     height
	     (caddr _mp)
      )
      (while
	(setq point1 (vlax-curve-getPointAtDist obj chainage))
	 (setq bearing (_ang ent (+ chainage dist) point1))
	 (_text point1 bearing to height (caddr point1))
	 (setq chainage (+ chainage dist))
      )
    )
    (_text p2 (_ang ent chainage p2) to height (caddr p2))
    (setq count (1+ count))
  )
  (princ)
)