;;;--------------------------------->DDLR-KILL<------------------------------------;;;
;;;                                                  ;;;
;;;                            LKILL.lsp Version 1.31                              ;;;
;;;                           :                                ;;;
;;;    :                                               ;;;
;;; LR-KILL:     .   .       ;;;
;;; DDLR-KILL:     .                                 ;;;
;;;   (ddlkill.dcl).                                            ;;;
;;;--------------------------------------------------------------------------------;;;

;;;   
(DEFUN LR-DEL-MAIN (ln optbit / i blkd ss0 en ed ans
      CHECK-BLOCK ATTREDEFDEL)

   ;;;    ,   
   (DEFUN CHECK-BLOCK (blkd / en ed flag)
      (SETQ
         en (CDR (ASSOC -2 blkd));   
         flag nil
         );SETQ
      (IF (= (LOGAND (CDR (ASSOC 70 blkd)) 1) 1); 
         (SETQ flag nil)
         (WHILE en
            (SETQ ed (ENTGET en));   
            (IF (= (STRCASE (CDR (ASSOC 8 ed))) (STRCASE ln))
               (SETQ
                  flag T
                  en nil)
               (SETQ en (ENTNEXT en));  . 
               );IF
            );WHILE
         );IF
      flag
      );DEFUN

   ;;;   (  Express Tools)
   (DEFUN ATTREDEFDEL ( / fltr ss cnt en ilay elst doit laylck LAYER-LOCKED)

      ;;;     (  Bonus Tools)
      (DEFUN LAYER-LOCKED (ln / en ed)
         (SETQ en (TBLOBJNAME "LAYER" ln)
            ed (ENTGET en)
            );SETQ
         (EQUAL 4
            (LOGAND 4 (CDR (ASSOC 70 ed)))
            );EQUAL
         );DEFUN

      (SETQ fltr (LIST '(0 . "INSERT") '(66 . 1))
         ss   (SSGET "_X" fltr)
         cnt  0
         );SETQ
      (WHILE (AND ss
            (> (SSLENGTH ss) 0)
            (SETQ en (SSNAME ss cnt))
            );AND
         (SETQ ed   (ENTGET en '("*"))
            ilay (CDR (ASSOC 8 ed))
            elst (LIST ed)
            doit NIL
            );SETQ
         (WHILE (/= "SEQEND" (CDR (ASSOC 0 (ENTGET (SETQ en (ENTNEXT en))))))
            (SETQ ed (ENTGET en '("*")))
            (IF (/= ln (CDR (ASSOC 8 ed)))
               (SETQ elst (CONS ed elst))
               (SETQ doit T)
               );IF
            );WHILE
         (SETQ elst (REVERSE elst)
            ed   (ENTGET en '("*"))
            );SETQ
         (IF (< 1 (LENGTH elst))
            (IF (OR doit (= ln (CDR (ASSOC 8 ed))))
               (PROGN
                  (ENTMAKE)
                  (FOREACH mbr elst (ENTMAKE mbr))
                  (ENTMAKE (SUBST (CONS 8 ilay) (ASSOC 8 ed) ed))
                  (ENTDEL (CDR (ASSOC -1 (CAR elst))))
                  );PROGN
               );IF
            (PROGN
               (ENTMAKE)
               (ENTMAKE (SUBST (CONS 66 0) (ASSOC 66 (CAR elst)) (CAR elst)))
               (IF (SETQ laylck (LAYER-LOCKED (CDR (ASSOC 8 (CAR elst)))))
                  (COMMAND "_.-LAYER" "_U" (CDR (ASSOC 8 (CAR elst))) "")
                  );IF
               (ENTDEL (CDR (ASSOC -1 (CAR elst))))
               (IF laylck (COMMAND "_.-LAYER" "_LO" (CDR (ASSOC 8 (CAR elst))) ""))
               );PROGN
            );IF
         (SETQ cnt (1+ cnt))
         );WHILE
      );DEFUN

   ;;;   (  Express Tools)
   (DEFUN BLKREDEFDEL (bnam / blk en ed fltr)
      (ENTMAKE)
      (SETQ blk (ENTGET (TBLOBJNAME "block" bnam)'("*"))
         blk (SUBST (CONS 8 "0") (ASSOC 8 blk) blk)
         en  (CDR (ASSOC -2 blk))
         );SETQ
      (ENTMAKE blk);  
      (WHILE en;  
         (SETQ ed (ENTGET en '("*")))
         (IF (/= (STRCASE (CDR (ASSOC 8 ed))) (STRCASE ln))
            (ENTMAKE ed)
            );IF
         (SETQ en   (ENTNEXT en))
         );WHILE
      (SETQ bnam (ENTMAKE (LIST (CONS 0 "endblk")))); 
      (IF (NOT (ENTNEXT (TBLOBJNAME "block" bnam)));    
         (PROGN
            (SETQ fltr (LIST '(-4 . "<AND")
                  '(0 . "INSERT")
                  (CONS 2 bnam)
                  '(-4 . "AND>")
                  );LIST
               );SETQ
            (IF (SETQ ss  (SSGET "_X" fltr))
               (COMMAND "_.ERASE" ss "");  
               );IF
            (IF (SETQ ss  (SSGET "_X" fltr))
               (PROGN
                  (SETQ cnt 0)
                  (WHILE (AND ss
                        (> (SSLENGTH ss) 0)
                        (SETQ en (SSNAME ss cnt))
                        );AND
                     (ENTDEL en)
                     (SETQ cnt (1+ cnt))
                     );WHILE
                  );PROGN
               );IF
            (IF (TBLOBJNAME "BLOCK" bnam)
               (COMMAND "_.PURGE" "_BLOCK" bnam "_N");  
               );IF
            );PROGN
         );IF
      );DEFUN

   ;;;  
   (ATTREDEFDEL)
   (SETQ ss0 (SSGET "_X" (LIST (CONS 8  ln)))
      i 0);SETQ
   (IF (NOT (NULL ss0))
      (PROGN
         (IF (OR (EQ (STRCASE ln) (STRCASE "Defpoints"))
               (EQ ln "0")
               );OR
            (PRINC (STRCAT "\n    \""
                  ln
                  "\"  ."
                  "\n     \""
                  ln
                  "\". "
                  );STRCAT
               );PRINC
            );IF
         (PRINC "\n...\n")
         (COMMAND "_.-layer" "_ON" ln
            "_Thaw" ln
            "_Unlock" ln
            ""
            );COMMAND
         (WHILE (<= i (- (SSLENGTH ss0) 1))
            (SETQ ed (ENTGET (SSNAME ss0 i)))
            (ENTDEL (SSNAME ss0 i))
            (SETQ i (1+ i))
            );WHILE
         );PROGN
      );IF
   (IF (= (LOGAND optbit 1) 1)
      (PROGN
         (SETQ blkd (TBLNEXT "BLOCK" T));SETQ
         (WHILE blkd
            (IF (CHECK-BLOCK blkd)
               (BLKREDEFDEL (CDR (ASSOC 2 blkd)))
               );IF
            (SETQ blkd (TBLNEXT "BLOCK"))
            );WHILE
         );PROGN
      );IF
   (IF (EQ (STRCASE (GETVAR "CLAYER")) (STRCASE ln))
      (SETVAR "CLAYER" "0")
      );IF
   (IF (NOT (OR (EQ (STRCASE ln) (STRCASE "Defpoints"))
            (EQ ln "0"));OR
         );NOT
      (COMMAND "_.PURGE" "_LAyers" ln "_No")
      );IF
   (COMMAND "_.REGENALL")
   (SETQ *error* error-save)
   (PRINC)
   );DEFUN

;;;    
;;;  
(DEFUN LR-KILL (/ ln error-save ans blockflag optbit)
   (SETQ cmdecho-save (GETVAR "CMDECHO")
      error-save *error*
      );SETQ
   (DEFUN *error* (msg)
      (IF  error-save (SETQ *error* error-save))
      (IF msg (PRINC "\n   "))
      (PRINC)
      );DEFUN
   (SETVAR "CMDECHO" 0)
   (COMMAND "_.undo" "_begin")
   (SETQ ln (GETSTRING "\n  : ")
      optbit 0);SETQ
   (WHILE (NOT (TBLSEARCH "LAYER" ln))
      (PRINC "\n c  \"")
      (PRINC ln)
      (PRINC "\"  .")
      (SETQ ln (GETSTRING "\n  : "))
      );WHILE
   (SETQ ln (STRCASE ln))
   (INITGET "Yes No")
   (SETQ ans (GETKWORD "\n ? (Yes/N) <N>: ")
      blockflag (= ans "Yes"));SETQ
   (IF blockflag (SETQ optbit (+ optbit 1)))
   (LR-DEL-MAIN ln optbit)
   (COMMAND "_.undo" "_end")
   (SETQ *error* error-save)
   (SETVAR "cmdecho" cmdecho-save)
   (PRINC)
   );DEFUN

;;;    
;;; 
(DEFUN DDLR-KILL (/ ln error-save cmdecho-save optbit lrlst
      dcl_id dialogLoaded userclick)
   (SETQ cmdecho-save (GETVAR "CMDECHO")
      error-save *error*
      );SETQ
   (DEFUN *error* (msg)
      (IF  error-save (SETQ *error* error-save))
      (IF msg (PRINC "\n   "))
      (PRINC)
      );DEFUN
   (SETVAR "CMDECHO" 0)
   (COMMAND "_.undo" "_begin")
   (SETQ dialogLoaded T
      dialogShow T
      );SETQ
;;  
   (IF (= -1 (SETQ dcl_id (LOAD_DIALOG "ddlkill.dcl")))
      (PROGN
         (PRINC "\n   ddlkill.dcl")
         (SETQ dialogLoaded nil)
         );PROGN
      );IF
;;  
   (IF (AND dialogLoaded
         (NOT (NEW_DIALOG "lk_box1" dcl_id))
         );AND
      (PROGN
         (PRINC "\n   lk_box1")
         (SETQ dialogShow nil)
         );PROGN
      );IF
;;  
   (SETQ lrlst nil)
   (IF (AND dialogLoaded dialogShow)
      (PROGN
         (SETQ ln (TBLNEXT "LAYER" T));SETQ
         (WHILE ln
            (SETQ lrlst (CONS (CDR (ASSOC 2 ln)) lrlst)
               ln (TBLNEXT "LAYER"))
            );WHILE
         (REVERSE lrlst)
         (START_LIST "lk_layer")
         (MAPCAR 'ADD_LIST lrlst)
         (END_LIST)
         (IF *blockflag
            (SET_TILE "lk_block" "1")
            );IF
         );PROGN
      );IF
;;   
   (ACTION_TILE "lk_block" "(SETQ *blockflag (= (GET_TILE \"lk_block\") \"1\"))")
   (ACTION_TILE "cancel" "(DONE_DIALOG) (SETQ userclick 0)")
   (ACTION_TILE "accept"
      (STRCAT "(PROGN (SETQ ln (NTH (ATOI (GET_TILE \"lk_layer\")) lrlst))"
         "(DONE_DIALOG) (SETQ userclick 1))"
         );STRCAT
      );ACTION_TILE
   (START_DIALOG)
   (UNLOAD_DIALOG dcl_id)
   (COND ((= userclick 1)
         (SETQ optbit 0
            ln (STRCASE ln)
            );SETQ
         (IF *blockflag (SETQ optbit (+ optbit 1)))
         (LR-DEL-MAIN ln optbit)
         );1
      );COND
   (COMMAND "_.undo" "_end")
   (SETQ *error* error-save)
   (SETVAR "cmdecho" cmdecho-save)
   (PRINC)
   );DEFUN

(IF (OR (NULL C:DDLR-KILL)
      (NOT (LISTP C:DDLR-KILL))
      );OR
   (DEFUN C:DDLR-KILL ()
      (DDLR-KILL)
      );DEFUN
   );IF
(IF (OR (NULL C:LR-KILL)
      (NOT (LISTP C:LR-KILL))
      );OR
   (DEFUN C:LR-KILL ()
      (LR-KILL)
      );DEFUN
   );IF
(PRINC "\nLKill.lsp ... ")
(PRINC)