(defun C:mlengthenl (/ ss delta)
  (defun *error* (msg /)
    (vla-endundomark adoc)
    (command "_.UNDO" "_End")
    (princ)
  ) ;_  defun
  (vl-load-com)
  (setq adoc (vla-get-activedocument (vlax-get-acad-object)))
  (vla-startundomark adoc)
  (setq	ss    nil
	delta (getdist "  : ")
  ) ;_  setq
  (mll
    (while (not ss) ;_ not
      (progn
	(prompt " :")
	(setq ss (ssget '((0 . "LINE"))))
      ) ;_ progn
    ) ;_ while
    delta
  ) ;_  mll
  (vla-endundomark adoc)
  (princ)
) ;_ defun

(defun mll (ss delta / n ang en ed dx10 dx11 pt10 pt11)
  (setq n (sslength ss))
  (repeat n
    (setq ed  (entget (setq en (ssname ss 0)))
	  ang (angle (setq pt10 (cdr (setq dx10 (assoc 10 ed))))
		     (setq pt11 (cdr (setq dx11 (assoc 11 ed))))
	      ) ;_  angle
	  ed  (subst (cons 10 (polar pt10 ang (- delta))) dx10 ed)
	  ed  (subst (cons 11 (polar pt11 ang delta)) dx11 ed)
    ) ;_ setq
    (ssdel en ss)
    (entmod ed)
  ) ;_ repeat
) ;_ defun