;     ,   .

(defun C:ZZM(/ *error* layer_set acsp adoc clay en line1 line2 obj obj1 obj2 ofdist sset ssunion x)
(defun *error* (msg)
  (if clay (setvar "clayer" clay))
    (if adoc
      (vla-endundomark adoc)
    )
    (cond ((not msg)) 
          ((member msg '("Function cancelled" "quit / exit abort")))
          ((princ (strcat "\n** Error: " msg " ** ")))
    )
    (princ)
  )
  ;; helper function
  (defun layer_set (lyr col ltp)
  (setvar "cmdecho" 0)  
  (if (tblsearch "layer" lyr)
  (command "_-layer" "_t" lyr "_u" lyr "_on" lyr  "_s" lyr "")
  (command "_-layer" "_m" lyr "_c" col lyr "_lt" ltp lyr ""))
  )

  ;;________________________________________________________;;
       (vla-startundomark(setq adoc (vla-get-activedocument
			(vlax-get-acad-object))))
       (setq acsp (vla-get-block
		    (vla-get-activelayout
		      adoc)))
  
  (setq clay (getvar "clayer"))
  (layer_set " " "1" "Continuous")
  (setvar "peditaccept" 1)
       (setq ofdist (getreal "\n  : "))
       (princ "\n : ")
      (if
       (setq sset (ssget  '((0 . "lwpolyline")(70 . 0))))
       (progn
       (while(setq en (ssname sset 0))
      (setq obj (vlax-ename->vla-object en))
       (setq obj1 (car (vl-catch-all-apply 'vlax-invoke (list obj 'offset ofdist))))
       (setq obj2 (car (vl-catch-all-apply 'vlax-invoke (list obj 'offset (* -1. ofdist)))))
      
       (setq line1 (vlax-invoke acsp 'addline (vlax-curve-getstartpoint obj1)(vlax-curve-getstartpoint obj2)) )
       (setq line2 (vlax-invoke acsp 'addline (vlax-curve-getendpoint obj1)(vlax-curve-getendpoint obj2)) )
      (setq ssunion (ssadd))
       (mapcar '(lambda (x)(ssadd x ssunion))(mapcar 'vlax-vla-object->ename (list obj1 obj2 line1 line2)))
       (command "_pedit" "_M" ssunion "" "_Join" 0.0 "_Width" 0.0 "")
       (command "_chprop" "_L" "" "_LA" " " "_Color" "BYLAYER" "")
       (vl-catch-all-apply 'vlax-invoke (list obj 'delete))
       (ssdel en sset)
       )
       )
       )
  (*error* nil)
  (princ)
  )
(or (vl-load-com)(princ))



