(defun c:otmetka (/
		  sys-var
		  selset
		  action
		  value
		  precision_value
		  str
		  precision_str
		  adoc
		  *error*
		  sep_num
		  lbl
		 )


  (defun *error* (msg)
    (vla-EndUndoMark adoc)
    (princ msg)
    (princ)
  ) ;_ end of defun

  (defun sep_num (str lbl / r_p rec-pat)
;;;  (sep_num " 159x6 L=3400" "first")
;;;  (" " "159" "x6 L=3400")

;;;  (sep_num " 159x6 L=3400" "last")
;;;  (" 159x6 L=" "3400")

;;;  (sep_num " 159x6 L=3400" nil)
;;;  (" " "159" "x" "6" " L=" "3400")

    (defun rec-pat (str / rec-pat)
      (defun rec-pat (temp str pat n /)
	(cond ((= str "") (list temp))
	      ((if (minusp n)
		 (not (member (substr str 1 1) pat))
		 (member (substr str 1 1) pat)
	       ) ;_ end of if
	       (if (/= temp "")
		 (cons temp (rec-pat "" str pat (- n)))
		 (rec-pat "" str pat (- n))
	       ) ;_ end of if
	      )
	      (t
	       (rec-pat	(strcat temp (substr str 1 1))
			(substr str 2)
			pat
			n
	       ) ;_ end of trim_gap
	      )
	) ;_ end of cond
      ) ;_ end of defun
      (rec-pat ""
	       str
	       '("0" "1" "2" "3" "4" "5" "6" "7" "8" "9" ".")
	       1
      ) ;_ end of rec-pat
    ) ;_ end of defun

    (if	(= (type lbl) 'STR)
      (progn
	(cond
	  ((= lbl "first")
	   (setq r_p (rec-pat str))
	   (cond
	     ((numberp (read (car r_p)))
	      (if (> (length r_p) 1)
		(list (car r_p) (apply 'strcat (cdr r_p)))
		r_p
	      ) ;_ end of if
	     )
	     ((numberp (read (cadr r_p)))
	      (if (> (length r_p) 2)
		(setq r_p (list	(car r_p)
				(cadr r_p)
				(apply 'strcat (cddr r_p))
			  ) ;_ end of list
		) ;_ end of setq
		r_p
	      ) ;_ end of if
	     )
	     (T r_p)
	   ) ;_ end of cond
	  )
	  ((= lbl "last")
	   (progn
	     (setq r_p (reverse (rec-pat str)))
	     (cond
	       ((numberp (read (car r_p)))
		(if (> (length r_p) 1)
		  (list (apply 'strcat (reverse (cdr r_p))) (car r_p))
		  r_p
		) ;_ end of if
	       )
	       ((numberp (read (cadr r_p)))
		(if (> (length r_p) 2)
		  (setq
		    r_p	(list (apply 'strcat (reverse (cddr r_p)))
			      (cadr r_p)
			      (car r_p)
			) ;_ end of list
		  ) ;_ end of setq
		  (reverse r_p)
		) ;_ end of if
	       )
	       (T r_p)
	     ) ;_ end of cond
	   ) ;_ end of progn
	  )
	) ;_ end of if
      ) ;_ end of progn
      (rec-pat str)
    ) ;_ end of if
  ) ;_ end of defun


  (vl-load-com)
  (vla-StartUndoMark
    (setq adoc (vla-get-ActiveDocument (vlax-get-acad-object)))
  ) ;_ end of vla-StartUndoMark
  (setq sys-var (getvar 'dimzin))
  (setvar 'dimzin 0)
  (if
    (and
      (setq selset (ssget "_:L" '((0 . "MTEXT,TEXT"))))
      (not
	(vl-catch-all-error-p
	  (vl-catch-all-apply
	    '(lambda ()
	       (setq lbl
		      (progn
			(initget "   _All Last First")
			(cadr
			  (assoc
			    (getkword
			      "    ?:[/ / ]<>"
			    ) ;_ end of getkword
			    '(("All" nil)
			      ("Last" "last")
			      ("First" "first")
			      (nil nil)
			     )
			  ) ;_ end of assoc
			) ;_ end of cadr
		      ) ;_ end of progn
	       ) ;_ end of setq
	       (setq action
		      (progn
			(initget "+ - * /")
			(cadr
			  (assoc (getkword
				   ":[+/-/*//]<+>"
				 ) ;_ end of getkword
				 '(("+" +) ("-" -) ("*" *) ("/" /) (nil +))
			  ) ;_ end of assoc
			) ;_ end of cadr
		      ) ;_ end of progn
	       ) ;_ end of setq
	       (initget 1)
	       (setq value (getreal "\n: "))
	       (initget 4)
	       (if (not	(setq precision_value
			       (getint
				 "\n   :<0>"
			       ) ;_ end of getint
			) ;_ end of setq
		   ) ;_ end of not
		 (setq precision_value 0)
	       ) ;_ end of if
	     ) ;_ end of lambda
	  ) ;_ end of vl-catch-all-apply
	) ;_ end of vl-catch-all-error-p
      ) ;_ end of not
    ) ;_ end of and
     (foreach ent
;;;	      (mapcar
;;;		'vlax-ename->vla-object
		  (vl-remove-if 'listp (mapcar 'cadr (ssnamex selset)))
;;;	      ) ;_ end of mapcar
;;;       (setq str (vla-get-textstring ent))
       (setq str (cdr (assoc 1 (entget ent)))
	     ent (vlax-ename->vla-object ent)
       ) ;_ end of setq
       (vla-put-textstring
	 ent
	 (apply
	   'strcat
	   (mapcar
	     '(lambda (str / pr_max)
		(setq precision_str
		       (length
			 (cdr (member 46 (vl-string->list str)))
		       ) ;_ end of length
		) ;_ end of setq
		(if (= (rtos (atof str) 2 precision_str) str)
		  (progn
		    (setq
		      str (rtos
			    ((eval action) (atof str) value)
			    2
			    (setq pr_max
;;;				   (apply 'max
;;;					  (list
				   precision_value
;;;					    precision_str
;;;					  ) ;_ end of list
;;;				   ) ;_ end of apply
			    ) ;_ end of setq
			  ) ;_ end of rtos
		    ) ;_ end of setq
		    ;|
		    (if	(> pr_max 0)
		      (vl-string-right-trim
			"."
			(vl-string-right-trim "0" str)
		      ) ;_ end of vl-string-right-trim
		      str
		    ) ;_ end of if
		    |;
		  ) ;_ end of progn
		  str
		) ;_ end of if
	      ) ;_ end of lambda
	     (sep_num str lbl)
	   ) ;_ end of mapcar
	 ) ;_ end of apply
       ) ;_ end of vla-put-textstring
;;;       (vla-put-color ent 3)
     ) ;_ end of foreach
  ) ;_ end of if
  (setvar 'dimzin sys-var)
  (vla-EndUndoMark adoc)
  (princ)
) ;_ end of defun

;;;(entget (car (entsel)))
;;;(vla-get-textstring (vlax-ename->vla-object (car (entsel))))
;;;(cdr (assoc 1 (entget (car (entsel)))))
;;;(vlax-dump-Object (vlax-ename->vla-object (car (entsel))))
;;;(vla-put-TextString (vlax-ename->vla-object (car (entsel))) " \U+E72910 L=3500")