

;;; 

(defun sv_l_r3d	(/     cpt   ept   hsv	 bsv   hp1   hp2   hp3	 lp1
		 rd1   rd2   pt1   pt2	 pt3   pt4   pt5   pt6	 pt7
		 pt8   pt9   pt10  pt11
		)

  (setq	hsv (nth 1 bb)
	bsv (nth 2 bb)
	hp1 (nth 3 bb)
	hp2 (nth 4 bb)
	hp3 (nth 5 bb)
	lp1 (nth 6 bb)
	rd1 (nth 7 bb)
	rd2 (nth 8 bb)
  ) ;_ end of setq

  (setq dlina (atof dlndt))

  (defun ris_shr ()

;;; 

    (defun shv_sc ()

      (setq cpt '(0.0 0.0))

;;;      (setvar "osmode" 0)
;;;      (setvar "aperture" 1)
      (setq pt0 (polar cpt (/ pi 2) (/ hsv 2.0000)))

      (setq pt1 (polar cpt 0 bsv))
      (setq pt11 (polar cpt (/ pi 2) hsv))
      (setq pt10 (polar pt11 0 bsv))
      (setq pt2 (polar pt1 (/ pi 2) lp1))
      (setq pt9 (polar pt10 (/ (* pi 3) 2) lp1))
      (setq pt8	(polar pt9
		       (/ (* pi 91) 72)
		       (* 2.0000 (* rd1 (sin (/ (* pi 17) 72))))
		) ;_ end of polar
      ) ;_ end of setq
      (setq pt3	(polar pt2
		       (/ (* pi 53) 72)
		       (* 2.0000 (* rd1 (sin (/ (* pi 17) 72))))
		) ;_ end of polar
      ) ;_ end of setq
      (setq pt4
	     (polar pt3
		    (/ (* pi 175) 180)
		    (/ (- (- bsv hp3) (* (- 1 (sin (/ pi 36))) (+ rd1 rd2)))
		       (cos (/ pi 36))
		    ) ;_ end of /
	     ) ;_ end of polar
      ) ;_ end of setq
      (setq pt7
	     (polar pt8
		    (/ (* pi 185) 180)
		    (/ (- (- bsv hp3) (* (- 1 (sin (/ pi 36))) (+ rd1 rd2)))
		       (cos (/ pi 36))
		    ) ;_ end of /
	     ) ;_ end of polar
      ) ;_ end of setq
      (setq pt5	(polar pt4
		       (/ (* pi 53) 72)
		       (* 2.0000 (* rd2 (sin (/ (* pi 17) 72))))
		) ;_ end of polar
      ) ;_ end of setq
      (setq pt6	(polar pt7
		       (/ (* pi 91) 72)
		       (* 2.0000 (* rd2 (sin (/ (* pi 17) 72))))
		) ;_ end of polar
      ) ;_ end of setq

      (setvar "CECOLOR" "bylayer")
      (setvar "CELTYPE" "bylayer")


      (command "_pline"	     pt1    cpt	   pt11	  pt10	 pt9	"_a"
	       pt8    "_l"   pt7    "_a"   pt6	  "_l"	 pt5	"_a"
	       pt4    "_l"   pt3    "_a"   pt2	  "_l"	 pt1	""
	      ) ;_  command

    )			      ;    shv_sc

    (shv_sc)

    (if
      (eq (strlen
	    (substr (substr (nth 0 bbb) 5)
		    (+ (strlen (itoa (atoi (substr (nth 0 bbb) 5)))) 2)
	    ) ;_  substr
	  )		      ;strlen 
	  4
      )			      ;eq
       (setq stepen 1)
       (setq stepen 2)
    )			      ;if

    (setq ves
	      (+ (atoi (substr (nth 0 bbb) 5)) ; 10
		 (/ (atoi
		      (substr (substr (nth 0 bbb) 5)
			      (+ (strlen (itoa (atoi (substr (nth 0 bbb) 5)))) 2)
		      ) ;_  substr
		    ) ;_  atoi
		    (expt 10.0 stepen)
		 )	      ;/
	      )		      ;+
	  ves (rtos (* ves (/ dlina 1000)) 2 2)
    )			      ;setq

    (setq gost (strcat (nth (atoi rr) aa) gost " " ves ""))
;;;------------------------------ 12.02.09  ----------------------------------
;;;    (command "_extrude" (entlast) "" dlina "")
    (if	(< (atoi (substr (getvar "acadver") 1 2)) 17)
      (command "_extrude" (entlast) "" dlina "0")
      (command "_extrude" (entlast) "" "_T" "0"  dlina)
    ) ;_  if
;;;------------------------------ 12.02.09    ------------------------------------------
    (command "_-hyperlink" "_insert" "_object" (entlast) "" "" "" gost)
    (command "_move" (entlast) "" cpt pause)

  ) ;_end of defun RIS_SHR

  (ris_shr)


  (prin1)

)			      ;    SV_L_R3D
;|Visual LISP Format Options
(72 2 30 2 T " " 72 9 1 1 0 T T nil T)
;***     ! ***|;
