;;;---------------------------------->TXT-CUT<-------------------------------------;;;
;;;          , ,   ;;;
;;;                                                 ;;;
;;;                           TXTCUT.lsp Version 2.0                               ;;;
;;;                           :                                ;;;
;;;          , ;;;
;;;      , ,          ;;;
;;;    ..                                            ;;;
;;; (    ).                                               ;;;
;;;--------------------------------------------------------------------------------;;;

;;; 
(DEFUN TXT-CUT ( / en men wtm es ofst sysvar-name sysvar-save error-save CUTAROUND)
   (SETQ sysvar-name (LIST "CMDECHO"
         "OSMODE");LIST
      error-save *error*
      sysvar-save (MAPCAR 'GETVAR sysvar-name)
      );SETQ
   (DEFUN *error* (msg)
      (IF  error-save (SETQ *error* error-save))
      (IF msg (PRINC "\n   "))
      ;;    
      (MAPCAR 'SETVAR sysvar-name sysvar-save)
      (PRINC)
      );DEFUN

   ;;;      
   (DEFUN CUTAROUND (men en wtm / objd tbx pt orgbnd n DTEXTBOX MTEXTBOX CUTBOX
         VERTS ATT-TEXT TRANSWTM)

      ;;;      WTM
      (DEFUN TRANSWTM (p wtm)
         (COND
            ((NULL wtm) p)
            (t (LIST
                  (+
                     (* (CAR p) (CAR (CAR wtm)))
                     (* (CADR p) (CADR (CAR wtm)))
                     (* (CADDR p) (CADDR (CAR wtm)))
                     (CADDDr (CAR wtm))
                     );+
                  (+
                     (* (CAR p) (CAR (CADR wtm)))
                     (* (CADR p) (CADR (CADR wtm)))
                     (* (CADDR p) (CADDR (CADR wtm)))
                     (CADDDr (CADR wtm)))
                  (+
                     (* (CAR p) (CAR (CADDR wtm)))
                     (* (CADR p) (CADR (CADDR wtm)))
                     (* (CADDR p) (CADDR (CADDR wtm)))
                     (CADDDr (CADDR wtm)))
                  );LIST
               );t
            );COND
         );DEFUN

      ;;;      (  Bonus Tools)
      (DEFUN ATT-TEXT (aent / tent ilist inum)
         (SETQ tent '((0 . "TEXT")))
         (FOREACH inum '(8 6 38 39 62 67 210 10 40 1 50 41 51 7 71 72 73 11)
            (IF (SETQ ilist (ASSOC inum aent))
               (SETQ tent (CONS ilist tent))
               );IF
            );FOREACH
         (SETQ
            tent (SUBST
               (CONS 73 (CDR (ASSOC 74 aent)))
               (ASSOC 72 tent)
               tent
               );SUBST
            );SETQ
         (ENTMAKE (REVERSE TENT))
         );DEFUN

      ;;;     4- ,    dtext
      (DEFUN DTEXTBOX (dtxtn / dtxtd tbx p1 p2 p3 p4)
         (SETQ dtxtd (ENTGET dtxtn)); 
         (IF (EQ (CDR (ASSOC 0 dtxtd)) "TEXT")
            (PROGN (COMMAND  "_.ucs" "_object" dtxtn)
               (SETQ  tbx (TEXTBOX dtxtd)
                  p1 (TRANS (CAR tbx) 1 0)
                  p2 (TRANS (LIST (CAADR tbx)(CADAR tbx)) 1 0)
                  p3 (TRANS (CADR tbx) 1 0)
                  p4 (TRANS (LIST (CAAR tbx)(CADADR tbx)) 1 0)
                  );SETQ
               (COMMAND "_.ucs" "_previous")
               (SETQ p1 (TRANS p1 0 1)
                  p2 (TRANS p2 0 1)
                  p3 (TRANS p3 0 1)
                  p4 (TRANS p4 0 1)
                  );SETQ
               (LIST p1 p2 p3 p4)
               );PROGN
            '()
            );IF
         );DEFUN

      ;;;     4- ,    mtext
      (DEFUN MTEXTBOX (mtxtn / mtxtd wdth hght ins just ang p1 p2 p3 p4)
         (SETQ mtxtd (ENTGET mtxtn)); 
         (IF (EQ (CDR (ASSOC 0 mtxtd)) "MTEXT")
            (PROGN
               (SETQ wdth (CDR (ASSOC 42 mtxtd));
                  hght (CDR (ASSOC 43 mtxtd));
                  ins  (TRANS (CDR (ASSOC 10 mtxtd)) 0 1); 
                  just (CDR (ASSOC 71 mtxtd)); 
                  ang  (CDR (ASSOC 50 mtxtd)); 
                  );SETQ
               (COND
                  ((= just 1); 
                     (SETQ p1 (POLAR ins (- ang (* PI 0.5)) hght) ; 
                        p2 (POLAR p1 ang wdth)                 ; 
                        p3 (POLAR ins ang wdth)                ; 
                        p4 ins                                 ; 
                        );SETQ
                     );just 1
                  ((= just 2);  
                     (SETQ p3 (POLAR ins ang (/ wdth 2))
                        p4 (POLAR ins (+ ang PI) (/ wdth 2))
                        p1 (POLAR p4 (- ang (* PI 0.5)) hght)
                        p2 (POLAR p1 ang wdth)
                        );SETQ
                     );just 2
                  ((= just 3); 
                     (SETQ p3 ins
                        p4 (POLAR ins (+ ang PI) wdth)
                        p1 (POLAR P4 (- ang (* PI 0.5)) HGHT)
                        p2 (POLAR P1 ang wdth)
                        );SETQ
                     );just 3
                  ((= just 4);  
                     (SETQ p4 (POLAR ins (+ ang (* PI 0.5)) (/ hght 2))
                        p3 (POLAR p4 ang wdth)
                        p1 (POLAR p4 (- ang (* PI 0.5)) hght)
                        p2 (POLAR p1 ang wdth)
                        );SETQ
                     );just 4
                  ((= just 5);   
                     (SETQ p4 (POLAR ins (- ang PI) (/ wdth 2))
                        p4 (POLAR p4 (+ ang (* PI 0.5)) (/ hght 2))
                        p3 (POLAR p4 ang wdth)
                        p1 (POLAR p4 (- ang (* PI 0.5)) hght)
                        p2 (POLAR p1 ang wdth)
                        );SETQ
                     );just 5
                  ((= just 6);  
                     (SETQ p3 (POLAR ins (+ ang (* PI 0.5)) (/ hght 2))
                        p4 (POLAR p3 (+ ang PI) wdth)
                        p1 (POLAR p4 (- ang (* PI 0.5)) hght)
                        p2 (POLAR p1 ang wdth)
                        );SETQ
                     );just 6
                  ((= just 7); 
                     (SETQ p1 ins
                        p2 (POLAR p1 ang wdth)
                        p3 (POLAR p2 (+ ang (* PI 0.5)) hght)
                        p4 (POLAR p1 (+ ang (* PI 0.5)) hght)
                        );SETQ
                     );just 7
                  ((= just 8);  
                     (SETQ p1 (POLAR ins (+ ang PI) (/ wdth 2))
                        p2 (POLAR p1 ang wdth)
                        p3 (POLAR p2 (+ ang (* PI 0.5)) hght)
                        p4 (POLAR p1 (+ ang (* PI 0.5)) hght)
                        );SETQ
                     );just 8
                  ((= just 9); 
                     (SETQ p2 ins
                        p1 (POLAR ins (+ ang PI) wdth)
                        p3 (POLAR p2 (+ ang (* PI 0.5)) hght)
                        p4 (POLAR p1 (+ ang (* PI 0.5)) hght)
                        );SETQ
                     );just 9
                  );COND
               (LIST p1 p2 p3 p4)
               );PROGN
            '()
            );IF
         );DEFUN

      ;;;   LwPolyline
      (DEFUN VERTS (ed)
         (COND
            ((NULL ed) nil)
            (t
               (COND
                  ((EQUAL 10 (CAAR ed))
                     (CONS (CDAR ed) (VERTS (CDR ed)))
                     ); vertex
                  (t (VERTS (CDR ed)))
                  );COND
               );t
            );COND
         );DEFUN

      ;;;     
      (DEFUN CUTBOX (en txten / ss en1 ed tbx)
         (SETQ tbx (VERTS (ENTGET en)))
         (COMMAND  "_.offset"
            (/ (DISTANCE (CAR tbx) (CADDDR tbx)) 100)
            en
            (POLAR
               (CAR tbx)
               (ANGLE (CAR tbx) (CADDR tbx))
               (/ 5 (DISTANCE (CAR tbx) (CADDR tbx)))
               );POLAR
            ""
            );COMMAND
         (SETQ en1 (ENTLAST)
            tbx (VERTS (ENTGET en1))
            );SETQ
         (ENTDEL en1)
         (COMMAND "_.trim" (ENTLAST) "" "_fence"
            (CAR tbx)
            (CADR tbx)
            (CADDR tbx)
            (CADDDR tbx)
            (CAR tbx)
            "" ""
            );COMMAND
         (SETQ tbx (VERTS (ENTGET en)))
         (ENTDEL en)
         (COMMAND "_.ucs" "_3point" (CAR tbx) (CADR tbx) (CADDDR tbx))
         (SETQ ss (SSGET "_W" '(0 0)
               (LIST (DISTANCE (CAR tbx) (CADR tbx))
                  (DISTANCE (CADR tbx) (CADDR tbx))
                  );LIST
               );SSGET
            );SETQ
         (COMMAND "_.ucs" "_previous")
         (IF ss
            (PROGN
               (IF (SSMEMB txten ss) (SSDEL txten ss))
               (IF (> (SSLENGTH ss) 0) (COMMAND "_.erase" ss ""))
               (SETQ ss nil)
               );PROGN
            );IF
         );DEFUN

      ;;;    CUTAROUND
      (COMMAND "_.ucs" "_world")
      (SETQ objd (ENTGET en))
      (IF (EQ (CDR (ASSOC 0 objd)) "ATTRIB")
         (PROGN
            (ATT-TEXT objd)
            (SETQ en (ENTLAST))
            );PROGN
         );IF
      (IF (AND wtm (EQ (CDR (ASSOC 0 objd)) "TEXT") )
         (PROGN
            (ENTMAKE objd)
            (SETQ en (ENTLAST))
            );PROGN
         );IF
      (IF (OR
            (EQ (CDR (ASSOC 0 objd)) "TEXT"); 
            (EQ (CDR (ASSOC 0 objd)) "MTEXT"); ( .. )
            (EQ (CDR (ASSOC 0 objd)) "ATTRIB");
            );OR
         (PROGN
            (SETQ tbx
               (COND
                  ((EQ (CDR (ASSOC 0 objd)) "TEXT") (DTEXTBOX en))
                  ((EQ (CDR (ASSOC 0 objd)) "MTEXT") (MTEXTBOX en))
                  ((EQ (CDR (ASSOC 0 objd)) "ATTRIB") (DTEXTBOX en))
                  );COND
               );SETQ
            (IF
               (OR 
                  (EQ (CDR (ASSOC 0 objd)) "ATTRIB")
                  (AND wtm (EQ (CDR (ASSOC 0 objd)) "TEXT"))
                  );OR
               (ENTDEL en)
               );IF
            (IF wtm
               (SETQ tbx (MAPCAR '(LAMBDA (x) (TRANSWTM x wtm)) tbx))
               );IF
            (COMMAND "_.pline")
            (FOREACH pt tbx (COMMAND pt))
            (COMMAND "_close")
            (IF (= *ofst 0.0)
               (CUTBOX (ENTLAST) en)
               (PROGN
                  (SETQ orgbnd (ENTLAST))
                  (COMMAND  "_.offset" *ofst orgbnd
                     (POLAR
                        (CAR tbx)
                        (+ PI (ANGLE (CAR tbx) (CADDR tbx)))
                        (/ 5 (DISTANCE (CAR tbx) (CADDR tbx)))
                        );POLAR
                     ""
                     );COMMAND
                  (ENTDEL orgbnd)
                  (CUTBOX (ENTLAST) men)
                  );PROGN
               );IF
            (REDRAW en)
            );PROGN
         (PRINC "\n  !")
         );IF
      (COMMAND "_.ucs" "_previous")
      );DEFUN

   ;;;    TXT-CUT
   (SETVAR "CMDECHO" 0)
   (COMMAND "_.undo" "_begin")
   (SETVAR "OSMODE" 15359)
   (COND
      ((EQ *ofst NIL)
         (INITGET 5)
         (SETQ *ofst (GETREAL "\n  : ")))
      (t (PRINC "\n   <")
         (PRINC *ofst)
         (PRINC ">: ")
         (INITGET 4)
         (SETQ ofst *ofst
            *ofst (GETREAL))
         (COND
            ((EQ *ofst NIL) (SETQ *ofst ofst))
            );COND
         );t
      );COND
   (WHILE (NULL es)
      (SETQ es (ENTSEL "\n , ,    : "))
      );WHILE
   (SETQ men (CAR es)
      en (CAR (NENTSELP "" (CADR es)))
      wtm (CADDR (NENTSELP "" (CADR es)))
      );SETQ
   (CUTAROUND men en wtm)
   (WHILE (SETQ es (ENTSEL "\n , ,    : "))
      (SETQ
         men (CAR es)
         en (CAR (NENTSELP "" (CADR es)))
         wtm (CADDR (NENTSELP "" (CADR es)))
         );SETQ
      (CUTAROUND men en wtm)
      );WHILE
   (COMMAND "_.undo" "_end")
   (MAPCAR 'SETVAR sysvar-name sysvar-save)
   (SETQ *error* error-save)
   (PRINC)
   );DEFUN

(IF (OR (NULL C:TXT-CUT)
      (NOT (LISTP C:TXT-CUT))
      );OR
   (DEFUN C:TXT-CUT ()
      (TXT-CUT)
      );DEFUN
   );IF
(PRINC "\nTxtCut.lsp ... ")
(PRINC)

